'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Types = {
    SUCCESS: 'success',
    DANGER: 'danger',
    INFO: 'info',
    WARNING: 'warning'
};

var PROPERTY_TYPES = {
    extra: _propTypes2.default.any,
    type: _propTypes2.default.oneOf([Types.SUCCESS, Types.WARNING, Types.DANGER, Types.INFO]),
    testId: _propTypes2.default.any
};
var DEFAULT_PROPS = {};

var Alert = function (_React$Component) {
    _inherits(Alert, _React$Component);

    function Alert(props) {
        _classCallCheck(this, Alert);

        return _possibleConstructorReturn(this, _React$Component.call(this, props));
    }

    Alert.prototype.render = function render() {
        var style = (0, _classnames2.default)(this.props.className, 'ros-alert', {
            'ros-alert--success': this.props.type === Types.SUCCESS,
            'ros-alert--danger': this.props.type === Types.DANGER,
            'ros-alert--info': this.props.type === Types.INFO,
            'ros-alert--warning': this.props.type === Types.WARNING
        });

        return _react2.default.createElement(
            'div',
            { 'data-test-id': this.props.testId, className: style },
            _react2.default.createElement(
                'div',
                { className: 'ros-alert__title' },
                this.props.title
            ),
            _react2.default.createElement(
                'div',
                { className: 'ros-alert__description' },
                this.props.description
            ),
            _react2.default.createElement(
                'div',
                { className: 'ros-alert__extra' },
                this.props.extra
            )
        );
    };

    return Alert;
}(_react2.default.Component);

Alert.propTypes = PROPERTY_TYPES;
Alert.defaultProps = DEFAULT_PROPS;
Alert.Type = Types;

exports.default = Alert;