'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _omit = require('lodash/omit');

var _omit2 = _interopRequireDefault(_omit);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Button = function (_React$Component) {
    _inherits(Button, _React$Component);

    function Button() {
        var _temp, _this, _ret;

        _classCallCheck(this, Button);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onClickButton = function (e) {
            if (_this.props.onClick && !_this.props.disabled) {
                _this.props.onClick(e);
            }
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    Button.prototype.render = function render() {
        var style = (0, _classnames2.default)(this.props.className, this.props.baseClassName, {
            disabled: this.props.disabled,
            selected: this.props.selected
        });

        var Element = this.props.as || 'div';
        return _react2.default.createElement(
            Element,
            _extends({}, (0, _omit2.default)(this.props, ['baseClassName', 'disabled', 'selected', 'className', 'onClick', 'data-test-id', 'testId', 'as']), {
                'data-test-id': this.props.testId,
                className: style,
                onClick: this.onClickButton
            }),
            this.props.children || this.props.value
        );
    };

    return Button;
}(_react2.default.Component);

Button.propTypes = {
    onClick: _propTypes2.default.func,
    selected: _propTypes2.default.bool,
    disabled: _propTypes2.default.bool,
    className: _propTypes2.default.string,
    baseClassName: _propTypes2.default.string,
    title: _propTypes2.default.string,
    value: _propTypes2.default.string,
    testId: _propTypes2.default.any,
    as: _propTypes2.default.string,
    children: _propTypes2.default.node
};
Button.defaultProps = {
    baseClassName: 'btn',
    onClick: _noop2.default
};
exports.default = Button;