'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../util/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    disabled: _propTypes2.default.bool,
    label: _propTypes2.default.string,
    defaultValue: _propTypes2.default.bool,
    value: _propTypes2.default.bool,
    onChange: _propTypes2.default.func,
    testId: _propTypes2.default.any
};
var DEFAULT_PROPS = {
    disabled: false,
    defaultValue: false,
    label: ''
};

var CheckBox = function (_React$Component) {
    _inherits(CheckBox, _React$Component);

    function CheckBox(props) {
        _classCallCheck(this, CheckBox);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            value: (0, _utils.isDefined)(props.value) ? props.value : props.defaultValue
        };
        _this.onClickCheckBox = _this.onClickCheckBox.bind(_this);
        return _this;
    }

    CheckBox.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        if ((0, _utils.isDefined)(nextProps.value)) {
            this.setState({
                value: nextProps.value
            });
        }
    };

    CheckBox.prototype.onClickCheckBox = function onClickCheckBox(event) {
        var _this2 = this;

        if (!this.props.disabled) {
            if ((0, _utils.isDefined)(this.props.value)) {
                this.onChange(!this.state.value);
            } else {
                this.setState({ value: !this.state.value }, function () {
                    _this2.onChange(_this2.state.value);
                });
            }
        }
    };

    CheckBox.prototype.onChange = function onChange(value) {
        if (this.props.onChange) {
            this.props.onChange(value);
        }
    };

    CheckBox.prototype.render = function render() {
        var _this3 = this;

        var style = (0, _classnames2.default)(this.props.className, {
            checkbox: true,
            disabled: this.props.disabled,
            checked: this.state.value
        });

        return _react2.default.createElement(
            'div',
            {
                'data-test-id': this.props.testId,
                'data-test-checked': this.state.value,
                tabIndex: '1',
                onClick: function onClick(e) {
                    return _this3.onClickCheckBox(e);
                },
                className: style
            },
            _react2.default.createElement('i', { className: 'im icon-ok' }),
            this.props.label ? _react2.default.createElement(
                'label',
                { className: 'checkbox-label' },
                this.props.label
            ) : null
        );
    };

    return CheckBox;
}(_react2.default.Component);

CheckBox.propTypes = PROPERTY_TYPES;
CheckBox.defaultProps = DEFAULT_PROPS;

exports.default = CheckBox;