'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Button = require('../Button/Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    body: _propTypes2.default.node,
    title: _propTypes2.default.node,
    onConfirm: _propTypes2.default.func,
    onCancel: _propTypes2.default.func,
    confirmBtnTxt: _propTypes2.default.string,
    cancelBtnText: _propTypes2.default.string,
    testId: _propTypes2.default.any
};
var DEFAULT_PROPS = {
    cancelBtnText: 'Cancel',
    confirmBtnText: 'Confirm',
    onCancel: function onCancel() {},
    onConfirm: function onConfirm() {}
};

var Confirmation = function (_React$Component) {
    _inherits(Confirmation, _React$Component);

    function Confirmation() {
        _classCallCheck(this, Confirmation);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    Confirmation.prototype.render = function render() {
        var style = (0, _classnames2.default)(this.props.className, 'ros-confirm');

        return _react2.default.createElement(
            'div',
            { 'data-test-id': this.props.testId, className: style },
            _react2.default.createElement(
                'h2',
                { className: 'ros-confirm__title' },
                this.props.title
            ),
            _react2.default.createElement(
                'div',
                { className: 'ros-confirm__body' },
                this.props.body
            ),
            _react2.default.createElement('div', { className: 'form-separator' }),
            _react2.default.createElement(
                'div',
                { className: 'form-btn-group' },
                _react2.default.createElement(
                    _Button2.default,
                    {
                        className: 'btn btn--primary',
                        testId: this.props.testId + '_confirm',
                        onClick: this.props.onConfirm
                    },
                    this.props.confirmBtnText
                ),
                _react2.default.createElement(
                    _Button2.default,
                    {
                        className: 'btn-link btn--m',
                        testId: this.props.testId + '_cancel',
                        onClick: this.props.onCancel
                    },
                    this.props.cancelBtnText
                )
            )
        );
    };

    return Confirmation;
}(_react2.default.Component);

Confirmation.propTypes = PROPERTY_TYPES;
Confirmation.defaultProps = DEFAULT_PROPS;

exports.default = Confirmation;