'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _dates = require('./utils/dates');

var _dates2 = _interopRequireDefault(_dates);

var _TimeGrid = require('./TimeGrid');

var _TimeGrid2 = _interopRequireDefault(_TimeGrid);

var _constants = require('./utils/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = _TimeGrid2.default.propTypes;
var DEFAULT_PROPS = _TimeGrid2.default.defaultProps;

var Day = function (_React$Component) {
    _inherits(Day, _React$Component);

    function Day(props) {
        _classCallCheck(this, Day);

        return _possibleConstructorReturn(this, _React$Component.call(this, props));
    }

    Day.prototype.render = function render() {
        var date = this.props.date;

        var _Day$range = Day.range(date),
            start = _Day$range.start,
            end = _Day$range.end;

        return _react2.default.createElement(_TimeGrid2.default, _extends({}, this.props, { start: start, end: end, eventOffset: 10 }));
    };

    return Day;
}(_react2.default.Component);

Day.navigate = function (date, action) {
    switch (action) {
        case _constants.navigate.PREVIOUS:
            return _dates2.default.add(date, -1, 'day');

        case _constants.navigate.NEXT:
            return _dates2.default.add(date, 1, 'day');

        default:
            return date;
    }
};

Day.range = function (date) {
    date = _dates2.default.startOf(date, 'day');
    return { start: date, end: date };
};

Day.propTypes = PROPERTY_TYPES;
Day.defaultProps = DEFAULT_PROPS;

exports.default = Day;