'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('./index');

var _index2 = _interopRequireDefault(_index);

var _index3 = require('@storybook/react/dist/client/preview/index');

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var nonWorkingDays = [new Date(2015, 2, 31), new Date(2015, 4, 2), new Date(2015, 3, 4), new Date(2015, 3, 5), new Date(2015, 3, 19), new Date(2015, 3, 25), new Date(2015, 3, 26), new Date(2015, 3, 20)];
var events = [{
    title: 'All Day Event',
    allDay: true,
    start: new Date(2015, 2, 30),
    end: new Date(2015, 2, 30),
    type: 'vacation'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day very, very very long label...',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day very, very very long label...',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day very, very very long label...',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day very, very very long label...',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day very, very very long label...',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day very, very very long label...',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day very, very very long label...',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Sick All Day',
    allDay: true,
    start: new Date(2015, 3, 0),
    end: new Date(2015, 3, 0),
    icon: 'icon-sick',
    type: 'sick'
}, {
    title: 'Long Event',
    start: new Date(2015, 3, 7),
    end: new Date(2015, 3, 20),
    type: 'businessTrip'
}, {
    title: 'DTS STARTS',
    start: new Date(2016, 2, 13, 0, 0, 0),
    end: new Date(2016, 2, 20, 0, 0, 0)
}, {
    title: 'DTS ENDS',
    start: new Date(2016, 10, 6, 0, 0, 0),
    end: new Date(2016, 10, 13, 0, 0, 0)
}, {
    title: 'Some Event',
    start: new Date(2015, 3, 9, 0, 0, 0),
    end: new Date(2015, 3, 9, 0, 0, 0)
}, {
    title: 'Conference',
    start: new Date(2015, 3, 11),
    end: new Date(2015, 3, 13),
    type: 'sprint',
    desc: 'Big conference for important people'
}, {
    title: 'Meeting',
    start: new Date(2015, 3, 12, 10, 30, 0, 0),
    end: new Date(2015, 3, 12, 12, 30, 0, 0),
    desc: 'Pre-meeting meeting, to prepare for the meeting'
}, {
    title: 'Lunch',
    start: new Date(2015, 3, 12, 12, 0, 0, 0),
    end: new Date(2015, 3, 12, 13, 0, 0, 0),
    desc: 'Power lunch'
}, {
    title: 'Meeting',
    start: new Date(2015, 3, 12, 14, 0, 0, 0),
    end: new Date(2015, 3, 12, 15, 0, 0, 0)
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Dinner',
    start: new Date(2015, 3, 12, 20, 0, 0, 0),
    end: new Date(2015, 3, 12, 21, 0, 0, 0),
    icon: 'icon-cal-vacation'
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Happy Hour',
    start: new Date(2015, 3, 12, 17, 0, 0, 0),
    end: new Date(2015, 3, 12, 17, 30, 0, 0),
    desc: 'Most important meal of the day'
}, {
    title: 'Birthday Party',
    start: new Date(2015, 3, 13, 7, 0, 0),
    end: new Date(2015, 3, 13, 10, 30, 0),
    type: 'birthday'
}, {
    title: 'Another Birthday Party',
    start: new Date(2015, 3, 27, 7, 0, 0),
    end: new Date(2015, 3, 28, 10, 30, 0),
    type: 'birthday',
    icon: 'icon-gift'
}, {
    title: 'Another Birthday Party',
    start: new Date(2015, 3, 27, 7, 0, 0),
    end: new Date(2015, 3, 28, 10, 30, 0),
    type: 'birthday',
    icon: 'icon-gift'
}, {
    title: 'Another Birthday Party',
    start: new Date(2015, 3, 27, 7, 0, 0),
    end: new Date(2015, 3, 28, 10, 30, 0),
    type: 'birthday',
    icon: 'icon-gift'
}, {
    title: 'Another Birthday Party',
    start: new Date(2015, 3, 27, 7, 0, 0),
    end: new Date(2015, 3, 28, 10, 30, 0),
    type: 'birthday',
    icon: 'icon-gift'
}, {
    title: 'Another Birthday Party',
    start: new Date(2015, 3, 27, 7, 0, 0),
    end: new Date(2015, 3, 28, 10, 30, 0),
    type: 'birthday',
    icon: 'icon-gift'
}, {
    title: 'Another Birthday Party',
    start: new Date(2015, 3, 27, 7, 0, 0),
    end: new Date(2015, 3, 28, 10, 30, 0),
    type: 'birthday',
    icon: 'icon-gift'
}];

var MyEvent = function (_React$Component) {
    _inherits(MyEvent, _React$Component);

    function MyEvent() {
        _classCallCheck(this, MyEvent);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    MyEvent.prototype.render = function render() {
        return _react2.default.createElement(
            _Popup2.default,
            { on: 'click', attachment: 'bottom center' },
            _react2.default.createElement(
                'div',
                null,
                this.props.title
            ),
            'bottom center'
        );
    };

    return MyEvent;
}(_react2.default.Component);

var EventPlannerDemo = function (_React$Component2) {
    _inherits(EventPlannerDemo, _React$Component2);

    function EventPlannerDemo() {
        var _temp, _this2, _ret;

        _classCallCheck(this, EventPlannerDemo);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this2 = _possibleConstructorReturn(this, _React$Component2.call.apply(_React$Component2, [this].concat(args))), _this2), _this2.getTitle = function (event) {
            if (event.icon) {
                return _react2.default.createElement(
                    'span',
                    { title: event.title },
                    _react2.default.createElement('i', { className: 'icon--xxs im ' + event.icon }),
                    ' ',
                    event.title
                );
            }
            return event.title;
        }, _temp), _possibleConstructorReturn(_this2, _ret);
    }

    EventPlannerDemo.prototype.eventStyleGetter = function eventStyleGetter(event, start, end, isSelected) {
        var style = {};
        switch (event.type) {
            case 'vacation':
                style = { backgroundColor: '#74cb14', color: 'white' };
                break;
            case 'businessTrip':
                style = { backgroundColor: '#398ff4', color: 'white' };
                break;
            case 'sick':
                style = { backgroundColor: '#ff455b', color: 'white' };
                break;
            case 'birthday':
                style = { backgroundColor: '#f5a623', color: 'white' };
                break;
            default:
                break;
        }

        if (isSelected) {
            style = _extends({}, style, { backgroundColor: '#000000' });
        }
        return {
            style: style
        };
    };

    EventPlannerDemo.prototype.render = function render() {
        return _react2.default.createElement(
            'div',
            { style: { width: '800px', height: '800px' } },
            _react2.default.createElement(_index2.default, {
                popup: true,
                onRangeSelected: function onRangeSelected(_ref) {
                    var start = _ref.start,
                        end = _ref.end;

                    console.log(start);
                    console.log(end);
                },
                titleAccessor: this.getTitle,
                events: events,
                nonWorkingDays: nonWorkingDays,
                selectable: true,
                onSelectEvent: function onSelectEvent(event) {
                    console.log('onSelectEvent');
                    console.dir(event);
                },
                onSelecting: function onSelecting(start, end) {
                    console.log('onSelectEvent');
                    return true;
                },
                defaultDate: new Date(2015, 3, 1),
                components: {
                    event: MyEvent
                },
                eventPropGetter: this.eventStyleGetter
            })
        );
    };

    return EventPlannerDemo;
}(_react2.default.Component);

(0, _index3.storiesOf)('EventPlanner', module).add('default', function () {
    return _react2.default.createElement(EventPlannerDemo, null);
});