'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _EventRowHOC = require('./EventRowHOC');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    segments: _propTypes2.default.array
};

var EventRow = function (_React$Component) {
    _inherits(EventRow, _React$Component);

    function EventRow(props) {
        _classCallCheck(this, EventRow);

        return _possibleConstructorReturn(this, _React$Component.call(this, props));
    }

    EventRow.prototype.render = function render() {
        var _this2 = this;

        var segments = this.props.segments;


        var lastEnd = 1;

        return _react2.default.createElement(
            'div',
            { className: 'rbc-row' },
            segments.reduce(function (row, _ref, li) {
                var event = _ref.event,
                    left = _ref.left,
                    right = _ref.right,
                    span = _ref.span;

                var key = _this2.getLvlKey(li, event);
                var gap = left - lastEnd;

                var content = _this2.renderEvent(event);

                if (gap) row.push(_this2.renderSpan(gap, key + '_gap'));

                row.push(_this2.renderSpan(span, key, content));

                lastEnd = right + 1;

                return row;
            }, [])
        );
    };

    return EventRow;
}(_react2.default.Component);

EventRow.propTypes = PROPERTY_TYPES;

exports.default = (0, _EventRowHOC.enhanceRowHOC)(EventRow);