'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.enhanceRowHOC = enhanceRowHOC;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _EventCell = require('./EventCell');

var _EventCell2 = _interopRequireDefault(_EventCell);

var _height = require('dom-helpers/query/height');

var _height2 = _interopRequireDefault(_height);

var _propTypes3 = require('./utils/propTypes');

var _eventLevels = require('./utils/eventLevels');

var _selection = require('./utils/selection');

var _localizer = require('./localizer');

var _localizer2 = _interopRequireDefault(_localizer);

var _accessors = require('./utils/accessors');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function enhanceRowHOC(ParentClass) {
    var PROPERTY_TYPES = {
        slots: _propTypes2.default.number.isRequired,
        end: _propTypes2.default.instanceOf(Date),
        start: _propTypes2.default.instanceOf(Date),

        selected: _propTypes2.default.oneOfType([_propTypes2.default.array, _propTypes2.default.object]),
        eventPropGetter: _propTypes2.default.func,
        titleAccessor: _propTypes3.accessor,
        allDayAccessor: _propTypes3.accessor,
        startAccessor: _propTypes3.accessor,
        endAccessor: _propTypes3.accessor,

        eventComponent: _propTypes3.elementType,
        onSelect: _propTypes2.default.func
    };

    var DEFAULT_PROPS = {
        segments: [],
        selected: [],
        slots: 7
    };

    var Enhance = function (_ParentClass) {
        _inherits(Enhance, _ParentClass);

        _createClass(Enhance, null, [{
            key: 'displayName',
            get: function get() {
                return ParentClass.displayName || ParentClass.name;
            }
        }]);

        function Enhance() {
            _classCallCheck(this, Enhance);

            var _this = _possibleConstructorReturn(this, _ParentClass.apply(this, arguments));

            _this.renderEvent = _this.renderEvent.bind(_this);
            _this.renderSpan = _this.renderSpan.bind(_this);
            _this.getRowHeight = _this.getRowHeight.bind(_this);
            _this.getLvlKey = _this.getLvlKey.bind(_this);
            return _this;
        }

        Enhance.prototype.renderEvent = function renderEvent(event) {
            var _props = this.props,
                eventPropGetter = _props.eventPropGetter,
                selected = _props.selected,
                start = _props.start,
                end = _props.end,
                startAccessor = _props.startAccessor,
                endAccessor = _props.endAccessor,
                titleAccessor = _props.titleAccessor,
                allDayAccessor = _props.allDayAccessor,
                eventComponent = _props.eventComponent,
                onSelect = _props.onSelect;


            return _react2.default.createElement(_EventCell2.default, {
                event: event,
                eventPropGetter: eventPropGetter,
                onSelect: onSelect,
                selected: (0, _selection.isSelected)(event, selected),
                startAccessor: startAccessor,
                endAccessor: endAccessor,
                titleAccessor: titleAccessor,
                allDayAccessor: allDayAccessor,
                slotStart: start,
                slotEnd: end,
                component: eventComponent
            });
        };

        Enhance.prototype.renderSpan = function renderSpan(len, key) {
            var content = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : ' ';
            var slots = this.props.slots;

            return _react2.default.createElement(
                'div',
                { key: key, className: 'rbc-row-segment', style: (0, _eventLevels.segStyle)(Math.abs(len), slots) },
                content
            );
        };

        Enhance.prototype.getLvlKey = function getLvlKey(index, event) {
            var start = (0, _accessors.accessor)(event, this.props.startAccessor);

            return '_lvl_' + index + '_' + _localizer2.default.format(start, 'DD.MM.YYYY');
        };

        Enhance.prototype.getRowHeight = function getRowHeight() {
            (0, _height2.default)((0, _reactDom.findDOMNode)(this));
        };

        return Enhance;
    }(ParentClass);

    Enhance.propTypes = PROPERTY_TYPES;
    Enhance.defaultProps = DEFAULT_PROPS;

    return Enhance;
}