'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _messages = require('./utils/messages');

var _messages2 = _interopRequireDefault(_messages);

var _constants = require('./utils/constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Toolbar = function (_React$Component) {
    _inherits(Toolbar, _React$Component);

    function Toolbar(props) {
        _classCallCheck(this, Toolbar);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.navigate = _this.navigate.bind(_this);
        _this.view = _this.view.bind(_this);
        _this.viewNamesGroup = _this.viewNamesGroup.bind(_this);
        return _this;
    }

    Toolbar.prototype.render = function render() {
        var _props = this.props,
            messages = _props.messages,
            label = _props.label;


        messages = (0, _messages2.default)(messages);

        return _react2.default.createElement(
            'div',
            { className: 'rbc-toolbar' },
            _react2.default.createElement(
                'span',
                { className: 'rbc-btn-group' },
                _react2.default.createElement(
                    'button',
                    { type: 'button', onClick: this.navigate.bind(null, _constants.navigate.TODAY) },
                    messages.today
                ),
                _react2.default.createElement(
                    'button',
                    { type: 'button', onClick: this.navigate.bind(null, _constants.navigate.PREVIOUS) },
                    messages.previous
                ),
                _react2.default.createElement(
                    'button',
                    { type: 'button', onClick: this.navigate.bind(null, _constants.navigate.NEXT) },
                    messages.next
                )
            ),
            _react2.default.createElement(
                'span',
                { className: 'rbc-toolbar-label' },
                label
            ),
            _react2.default.createElement(
                'span',
                { className: 'rbc-btn-group' },
                this.viewNamesGroup(messages)
            )
        );
    };

    Toolbar.prototype.navigate = function navigate(action) {
        this.props.onNavigate(action);
    };

    Toolbar.prototype.view = function view(_view) {
        this.props.onViewChange(_view);
    };

    Toolbar.prototype.viewNamesGroup = function viewNamesGroup(messages) {
        var _this2 = this;

        //eslint-disable-line
        var viewNames = this.props.views;
        var view = this.props.view;

        if (viewNames.length > 1) {
            return viewNames.map(function (name) {
                return _react2.default.createElement(
                    'button',
                    {
                        type: 'button',
                        key: name,
                        className: (0, _classnames2.default)({ 'rbc-active': view === name }),
                        onClick: _this2.view.bind(null, name)
                    },
                    messages[name]
                );
            });
        }
    };

    return Toolbar;
}(_react2.default.Component);

exports.default = Toolbar;