'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _cardTitle;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _types = require('../types');

var _types2 = _interopRequireDefault(_types);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var cardTitle = (_cardTitle = {}, _defineProperty(_cardTitle, _types2.default.error, 'Error'), _defineProperty(_cardTitle, _types2.default.success, 'Success'), _defineProperty(_cardTitle, _types2.default.waring, 'Warning'), _defineProperty(_cardTitle, _types2.default.info, 'Info'), _cardTitle);

var FeedbackCard = function (_React$Component) {
    _inherits(FeedbackCard, _React$Component);

    function FeedbackCard() {
        var _temp, _this, _ret;

        _classCallCheck(this, FeedbackCard);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this._onClose = function (e) {
            _this.props.onClose(_this.props.id);
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    FeedbackCard.prototype.render = function render() {
        var waring = _types2.default.waring,
            success = _types2.default.success,
            error = _types2.default.error,
            info = _types2.default.info;
        var type = this.props.type;


        var className = (0, _classnames2.default)(this.props.className, 'card', {
            'card--success': success === type,
            'card--error': error === type,
            'card--warning': waring === type,
            'card--info': info === type
        });

        return _react2.default.createElement(
            'div',
            { 'data-test-id': this.props.testId, className: className },
            _react2.default.createElement(
                'div',
                { className: 'card__content' },
                _react2.default.createElement('i', { className: 'im card__icon' }),
                _react2.default.createElement(
                    'div',
                    { className: 'card-message' },
                    _react2.default.createElement(
                        'div',
                        { className: 'card-message__title' },
                        this.props.title || cardTitle[type]
                    ),
                    _react2.default.createElement(
                        'div',
                        { className: 'card-message__description' },
                        _react2.default.createElement('span', { dangerouslySetInnerHTML: { __html: this.props.text } })
                    ),
                    _react2.default.createElement('i', { onClick: this._onClose, className: 'im icon-close close-message' })
                )
            )
        );
    };

    return FeedbackCard;
}(_react2.default.Component);

FeedbackCard.propTypes = {
    id: _propTypes2.default.oneOfType([_propTypes2.default.string, _propTypes2.default.number]),
    onClose: _propTypes2.default.func,
    text: _propTypes2.default.string.isRequired,
    title: _propTypes2.default.string,
    type: _propTypes2.default.string.isRequired,
    testId: _propTypes2.default.any
};
FeedbackCard.defaultProps = {
    onClose: _noop2.default
};
exports.default = FeedbackCard;