'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('@storybook/react/dist/client/preview/index');

var _FeedbackManager = require('./FeedbackManager/FeedbackManager');

var _FeedbackManager2 = _interopRequireDefault(_FeedbackManager);

var _types = require('./types');

var _types2 = _interopRequireDefault(_types);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _ButtonGroup = require('../Button/ButtonGroup');

var _ButtonGroup2 = _interopRequireDefault(_ButtonGroup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FBState = function (_React$Component) {
    _inherits(FBState, _React$Component);

    function FBState() {
        var _temp, _this, _ret;

        _classCallCheck(this, FBState);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
            messages: []
        }, _this.createFeedbackCard = function () {
            var id = Date.now() + '' + Math.random() + '';
            var keys = Object.keys(_types2.default);
            var msgType = _types2.default[keys[Math.floor(Math.random() * keys.length)]];
            _this.setState({
                messages: [{
                    id: id,
                    text: 'Message width id:' + id + ' has been created',
                    type: msgType
                }].concat(_toConsumableArray(_this.state.messages))
            });
        }, _this.clearCards = function () {
            _this.setState({
                messages: []
            });
        }, _this.onCloseMessage = function (id) {
            _this.setState({
                messages: _this.state.messages.filter(function (m) {
                    return m.id !== id;
                })
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    FBState.prototype.render = function render() {
        return _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
                _Button2.default,
                { onClick: this.createFeedbackCard, className: 'btn--primary' },
                'Generate Feedback card!'
            ),
            _react2.default.createElement(
                _Button2.default,
                { onClick: this.clearCards, className: 'btn--success' },
                'Clear Cards'
            ),
            _react2.default.createElement(_FeedbackManager2.default, { messages: this.state.messages, onCloseMessage: this.onCloseMessage })
        );
    };

    return FBState;
}(_react2.default.Component);

(0, _index.storiesOf)('FeedbackManager', module).add('default', function () {
    return _react2.default.createElement(FBState, null);
});