'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _values = require('lodash/values');

var _values2 = _interopRequireDefault(_values);

var _CSSTransitionGroup = require('react-transition-group/CSSTransitionGroup');

var _CSSTransitionGroup2 = _interopRequireDefault(_CSSTransitionGroup);

var _FeedbackCard = require('../FeedbackCard');

var _FeedbackCard2 = _interopRequireDefault(_FeedbackCard);

var _types = require('../types');

var _types2 = _interopRequireDefault(_types);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var allowedTypes = (0, _values2.default)(_types2.default);

var FeedbackManager = function (_React$Component) {
    _inherits(FeedbackManager, _React$Component);

    function FeedbackManager() {
        var _temp, _this, _ret;

        _classCallCheck(this, FeedbackManager);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this._renderCards = function () {
            return _this.props.messages.map(function (message) {
                return _react2.default.createElement(_FeedbackCard2.default, {
                    key: message.id,
                    id: message.id,
                    text: message.text,
                    title: message.title,
                    type: message.type,
                    onClose: _this.props.onCloseMessage
                });
            });
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    FeedbackManager.prototype.render = function render() {
        return _react2.default.createElement(
            'div',
            { 'data-test-id': this.props.testId, className: 'feedback' },
            _react2.default.createElement(
                _CSSTransitionGroup2.default,
                {
                    transitionEnter: true,
                    transitionLeave: true,
                    transitionEnterTimeout: 300,
                    transitionLeaveTimeout: 300,
                    transitionName: 'card'
                },
                this._renderCards()
            )
        );
    };

    return FeedbackManager;
}(_react2.default.Component);

FeedbackManager.propTypes = {
    onCloseMessage: _propTypes2.default.func,
    messages: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        text: _propTypes2.default.string,
        type: _propTypes2.default.oneOf(allowedTypes)
    })),
    testId: _propTypes2.default.any
};
FeedbackManager.defaultProps = {
    onCloseMessage: _noop2.default
};
exports.default = FeedbackManager;