'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _utils = require('../util/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    error: _propTypes2.default.string,
    touched: _propTypes2.default.bool,
    valid: _propTypes2.default.bool,
    label: _propTypes2.default.node,
    testId: _propTypes2.default.string,
    colClass: _propTypes2.default.string
};
var DEFAULT_PROPS = {};

var FormField = function (_Component) {
    _inherits(FormField, _Component);

    function FormField() {
        _classCallCheck(this, FormField);

        return _possibleConstructorReturn(this, _Component.apply(this, arguments));
    }

    FormField.prototype.getMessage = function getMessage() {
        var style = (0, _classnames2.default)({
            'form-field__error-msg': this.props.error
        });

        return this.props.error && !this.isValid() ? _react2.default.createElement(
            'span',
            { className: style },
            this.props.error
        ) : null;
    };

    FormField.prototype.isValid = function isValid() {
        if ((0, _utils.isDefined)(this.props.touched) && !this.props.touched) {
            return true;
        }
        return this.props.valid;
    };

    FormField.prototype.render = function render() {
        var className = (0, _classnames2.default)(this.props.colClass, {
            'form-field': true,
            'form-field-error': !this.isValid()
        });

        var control = _react2.default.cloneElement(_react2.default.Children.only(this.props.children), {
            onChange: this.props.onChange,
            onBlur: this.props.onBlur,
            value: this.props.value
        });

        return _react2.default.createElement(
            'div',
            { className: className, 'data-test-id': this.props.testId },
            _react2.default.createElement(
                'label',
                { className: 'form-field__label' },
                this.props.label
            ),
            _react2.default.createElement(
                'div',
                { className: 'form-field__control' },
                control
            ),
            this.getMessage()
        );
    };

    return FormField;
}(_react.Component);

FormField.propTypes = PROPERTY_TYPES;
FormField.defaultProps = DEFAULT_PROPS;

exports.default = FormField;