'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Input = require('../Input/Input');

var _Input2 = _interopRequireDefault(_Input);

var _sizes = require('../util/constant/sizes');

var sizes = _interopRequireWildcard(_sizes);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var LEFT = 'left';
var RIGHT = 'right';

var PROPERTY_TYPES = {
    iconClassName: _propTypes2.default.string.isRequired,
    onChange: _propTypes2.default.func,
    onClick: _propTypes2.default.func,
    onKeyPress: _propTypes2.default.func,
    onKeyDown: _propTypes2.default.func,
    position: _propTypes2.default.oneOf([LEFT, RIGHT]),
    readOnly: _propTypes2.default.bool,
    fluid: _propTypes2.default.bool,
    placeholder: _propTypes2.default.string,
    inputRef: _propTypes2.default.func,
    size: sizes.anySize,
    value: _propTypes2.default.string,
    testId: _propTypes2.default.any
};

var DEFAULT_PROPS = {
    position: LEFT,
    readOnly: false,
    fluid: false,
    size: sizes.NORMAL
};

var IconInput = function (_React$Component) {
    _inherits(IconInput, _React$Component);

    function IconInput(props) {
        _classCallCheck(this, IconInput);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            focused: false
        };
        return _this;
    }

    IconInput.prototype.render = function render() {
        var _this2 = this;

        var className = (0, _classnames2.default)('icon-input', this.props.className, {
            'icon-input--left': this.props.position === LEFT,
            'icon-input--right': this.props.position === RIGHT,
            'icon-input--fluid': this.props.fluid,
            'icon-input--focused': this.state.focused
        });

        var iconClassName = (0, _classnames2.default)(this.props.iconClassName, {
            'icon--xs': true //TODO ???
        });

        return _react2.default.createElement(
            'div',
            { className: className, onClick: this.props.onClick },
            _react2.default.createElement(_Input2.default, _extends({}, this.props, {
                type: 'text',
                value: this.props.value,
                onChange: this.props.onChange,
                onKeyPress: this.props.onKeyPress,
                onKeyDown: this.props.onKeyDown,
                readOnly: this.props.readOnly,
                fluid: this.props.fluid,
                placeholder: this.props.placeholder,
                size: this.props.size,
                onFocus: function onFocus() {
                    return _this2.setState({ focused: true });
                },
                onBlur: function onBlur() {
                    return _this2.setState({ focused: false });
                }
            })),
            _react2.default.createElement('i', { className: iconClassName })
        );
    };

    return IconInput;
}(_react2.default.Component);

IconInput.propTypes = PROPERTY_TYPES;
IconInput.defaultProps = DEFAULT_PROPS;

exports.default = IconInput;