'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Popup = require('../Popup/Popup');

var _Popup2 = _interopRequireDefault(_Popup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Modal = function (_React$Component) {
    _inherits(Modal, _React$Component);

    function Modal() {
        _classCallCheck(this, Modal);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    Modal.prototype.render = function render() {
        return _react2.default.createElement(
            _Popup2.default,
            {
                open: this.props.open,
                openByDefault: true,
                on: this.props.on || this.props.trigger && 'click',
                modal: true,
                attachment: 'middle center',
                popupClassName: (0, _classnames2.default)(this.props.popupClassName, 'popup'),
                closeOnClickOutside: this.props.closeOnClickOutside,
                onClose: this.props.onClose
            },
            this.props.trigger || _react2.default.createElement('span', null),
            this.props.children
        );
    };

    return Modal;
}(_react2.default.Component);

exports.default = Modal;


Modal.propTypes = {
    open: _propTypes2.default.bool,
    on: _Popup2.default.propTypes.on,
    trigger: _propTypes2.default.element,
    popupClassName: _propTypes2.default.string,
    closeOnClickOutside: _propTypes2.default.bool,
    onClose: _propTypes2.default.func
};