'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _index = require('@storybook/react/dist/client/preview/index');

var _Modal = require('./Modal');

var _Modal2 = _interopRequireDefault(_Modal);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var ManagedModal = function (_React$Component) {
    _inherits(ManagedModal, _React$Component);

    function ManagedModal() {
        var _temp, _this, _ret;

        _classCallCheck(this, ManagedModal);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
            isOpen: true
        }, _this.timeout = null, _this.doClose = function () {
            _this.setState({ isOpen: false });

            if (_this.timeout) {
                clearTimeout(_this.timeout);
            }
            _this.timeout = window.setTimeout(_this.reOpen, 3000);
        }, _this.reOpen = function () {
            _this.setState({ isOpen: true });
            _this.timeout = null;
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    ManagedModal.prototype.componentWillUnmount = function componentWillUnmount() {
        if (this.timeout) {
            clearTimeout(this.timeout);
        }
    };

    ManagedModal.prototype.render = function render() {
        return _react2.default.createElement(
            _Modal2.default,
            { open: this.state.isOpen, onClose: this.doClose },
            this.props.children
        );
    };

    return ManagedModal;
}(_react2.default.Component);

(0, _index.storiesOf)('Modal', module).add('default', function () {
    return _react2.default.createElement(
        _Modal2.default,
        null,
        _react2.default.createElement(
            'h1',
            null,
            'I should open automatically'
        )
    );
}).add('Close on click outside', function () {
    return _react2.default.createElement(
        _Modal2.default,
        { closeOnClickOutside: true },
        _react2.default.createElement(
            'h1',
            null,
            'I will close on dimmer click'
        )
    );
}).add('Managed 1', function () {
    return _react2.default.createElement(
        _Modal2.default,
        { open: true },
        _react2.default.createElement(
            'h1',
            null,
            'You won\'t be able to close me'
        )
    );
}).add('Managed 2', function () {
    return _react2.default.createElement(
        ManagedModal,
        null,
        _react2.default.createElement(
            'h1',
            null,
            'I will re-open after 3 seconds'
        )
    );
}).add('Colored', function () {
    return _react2.default.createElement(
        _Modal2.default,
        { open: true, popupClassName: 'popup-blue-border' },
        _react2.default.createElement(
            'h1',
            null,
            'I have blue border'
        )
    );
});