'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Button = require('../Button/Button');

var _Button2 = _interopRequireDefault(_Button);

var _MonthPicker = require('../MonthPicker/MonthPicker');

var _MonthPicker2 = _interopRequireDefault(_MonthPicker);

var _Pager = require('../Pager/Pager');

var _Pager2 = _interopRequireDefault(_Pager);

var _utils = require('../util/utils');

var utils = _interopRequireWildcard(_utils);

var _dateUtils = require('../util/date-utils');

var dateUtils = _interopRequireWildcard(_dateUtils);

var _dateFormats = require('../util/date-formats');

var dateFormats = _interopRequireWildcard(_dateFormats);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    onChange: _propTypes2.default.func,
    value: _propTypes2.default.string
};

var DEFAULT_PROPS = {
    format: dateFormats.DD_MM_YYYY
};

var MonthPager = function (_React$Component) {
    _inherits(MonthPager, _React$Component);

    function MonthPager(props) {
        _classCallCheck(this, MonthPager);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            value: dateUtils.getFirstDayOfMonth(dateUtils.getToday())
        };
        return _this;
    }

    MonthPager.prototype.prev = function prev() {
        var value = dateUtils.addMonths(this.getValue(), -1);
        this.monthChanged(value);
    };

    MonthPager.prototype.next = function next() {
        var value = dateUtils.addMonths(this.getValue(), 1);
        this.monthChanged(value);
    };

    MonthPager.prototype.onMonthChange = function onMonthChange(newValue) {
        var value = dateUtils.parse(newValue, this.props.format);
        this.monthChanged(value);
    };

    MonthPager.prototype.getValue = function getValue() {
        return this.parse(this.props.value) || this.state.value;
    };

    MonthPager.prototype.monthChanged = function monthChanged(value) {
        if (this.props.onChange) {
            this.props.onChange(this.format(value));
        }

        if (!utils.isDefined(this.props.value)) {
            this.setState({
                value: value
            });
        }
    };

    MonthPager.prototype.format = function format(value) {
        return dateUtils.format(value, this.props.format);
    };

    MonthPager.prototype.parse = function parse(value) {
        return dateUtils.parse(value, this.props.format);
    };

    MonthPager.prototype.render = function render() {
        var _this2 = this;

        return _react2.default.createElement(
            _Pager2.default,
            { onPrevBtnClick: function onPrevBtnClick() {
                    return _this2.prev();
                }, onNextBtnClick: function onNextBtnClick() {
                    return _this2.next();
                } },
            _react2.default.createElement(
                _MonthPicker2.default,
                {
                    value: this.format(this.getValue()),
                    format: this.props.format,
                    onChange: function onChange(value) {
                        return _this2.onMonthChange(value);
                    },
                    formatMonth: dateFormats.formatMonthYearHeader
                },
                _react2.default.createElement(_Button2.default, { baseClassName: 'ros-pager__month-picker' })
            )
        );
    };

    return MonthPager;
}(_react2.default.Component);

MonthPager.propTypes = PROPERTY_TYPES;
MonthPager.defaultProps = DEFAULT_PROPS;

exports.default = MonthPager;