'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Popup = require('../../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    className: _propTypes2.default.string,
    active: _propTypes2.default.bool,
    right: _propTypes2.default.bool
};
var DEFAULT_PROPS = {
    className: ''
};

var NavDropDownItem = function (_React$Component) {
    _inherits(NavDropDownItem, _React$Component);

    function NavDropDownItem() {
        _classCallCheck(this, NavDropDownItem);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    NavDropDownItem.prototype.render = function render() {
        var navItemClassNames = (0, _classnames2.default)(this.props.className, {
            'rm-nav-bar__item': true,
            'rm-nav-bar__item--right': this.props.right,
            'rm-nav-bar__item--active': this.props.active
        });

        return _react2.default.createElement(
            _Popup2.default,
            { targetClassName: navItemClassNames, attachment: 'bottom right', on: 'click' },
            this.props.children[0],
            this.props.children[1]
        );
    };

    return NavDropDownItem;
}(_react2.default.Component);

exports.default = NavDropDownItem;


NavDropDownItem.propTypes = PROPERTY_TYPES;
NavDropDownItem.defaultProps = DEFAULT_PROPS;