'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var NavItem = function (_React$Component) {
    _inherits(NavItem, _React$Component);

    function NavItem() {
        _classCallCheck(this, NavItem);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    NavItem.prototype.render = function render() {
        var _this2 = this;

        var navItemClassNames = (0, _classnames2.default)(this.props.className, 'rm-nav-bar__item', {
            'rm-nav-bar__item--right': this.props.right,
            'rm-nav-bar__item--active': this.props.active,
            'rm-nav-bar__item--with-hover-effect': this.props.withHoverEffect
        });

        return _react2.default.createElement(
            'div',
            { onClick: function onClick(e) {
                    return _this2.onClick(e);
                }, style: this.props.style, className: navItemClassNames },
            this.props.children
        );
    };

    NavItem.prototype.onClick = function onClick(e) {
        e.preventDefault();
        if (this.props.onClick) {
            this.props.onClick(e);
        }
    };

    return NavItem;
}(_react2.default.Component);

exports.default = NavItem;


NavItem.propTypes = {
    className: _propTypes2.default.string,
    style: _propTypes2.default.object,
    onClick: _propTypes2.default.func,
    active: _propTypes2.default.bool,
    withHoverEffect: _propTypes2.default.bool,
    right: _propTypes2.default.bool
};

NavItem.defaultProps = {
    className: '',
    style: {}
};