'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    onPrevBtnClick: _propTypes2.default.func,
    onNextBtnClick: _propTypes2.default.func,
    value: _propTypes2.default.any,
    prevBtnIcon: _propTypes2.default.string,
    nextBtnIcon: _propTypes2.default.string
};

var DEFAULT_PROPS = {
    prevBtnIcon: 'im icon-arrow-thin-left',
    nextBtnIcon: 'im icon-arrow-thin-right'
};

var Pager = function (_React$Component) {
    _inherits(Pager, _React$Component);

    function Pager(props) {
        _classCallCheck(this, Pager);

        return _possibleConstructorReturn(this, _React$Component.call(this, props));
    }

    Pager.prototype.render = function render() {
        var _this2 = this;

        var style = (0, _classnames2.default)('ros-pager', this.props.className);
        var nextBtnStyle = (0, _classnames2.default)('ros-pager__btn', this.props.nextBtnIcon);
        var prevBtnStyle = (0, _classnames2.default)('ros-pager__btn', this.props.prevBtnIcon);

        return _react2.default.createElement(
            'div',
            { className: style },
            _react2.default.createElement('i', {
                className: prevBtnStyle,
                onClick: function onClick() {
                    if (_this2.props.onPrevBtnClick) {
                        _this2.props.onPrevBtnClick();
                    }
                }
            }),
            _react2.default.createElement(
                'div',
                { className: 'ros-pager__value' },
                this.props.children
            ),
            _react2.default.createElement('i', {
                className: nextBtnStyle,
                onClick: function onClick() {
                    if (_this2.props.onNextBtnClick) {
                        _this2.props.onNextBtnClick();
                    }
                }
            })
        );
    };

    return Pager;
}(_react2.default.Component);

Pager.propTypes = PROPERTY_TYPES;
Pager.defaultProps = DEFAULT_PROPS;

exports.default = Pager;