'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PopupElement = function (_React$Component) {
    _inherits(PopupElement, _React$Component);

    function PopupElement() {
        _classCallCheck(this, PopupElement);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    PopupElement.prototype.componentDidMount = function componentDidMount() {
        this.props.didMount(this._popupElement);
    };

    PopupElement.prototype.componentWillUnmount = function componentWillUnmount() {
        this.props.onUnmount();
    };

    PopupElement.prototype.render = function render() {
        var _this2 = this;

        var attrForType = this.context.parentType;
        var attrForId = this.props.id || this.context.id;
        var testId = this.props.testId || this.context.testId && this.context.testId + '_popup';
        return _react2.default.createElement(
            'div',
            {
                ref: function ref(popupElement) {
                    return _this2._popupElement = popupElement;
                },
                'data-attr-for-type': attrForType,
                'data-attr-for-id': attrForId,
                'data-test-id': testId,
                className: 'popup-content-wrapper',
                style: this.props.style
            },
            _react2.default.createElement(
                'div',
                { className: 'popup-content' },
                this.props.modal && _react2.default.createElement('i', { className: 'im icon-close popup-close icon--xxs', onClick: function onClick() {
                        return _this2.props.close();
                    } }),
                this.props.children
            )
        );
    };

    return PopupElement;
}(_react2.default.Component);

PopupElement.contextTypes = {
    id: _propTypes2.default.string,
    parentType: _propTypes2.default.string,
    testId: _propTypes2.default.string,
    style: _propTypes2.default.any
};

exports.default = PopupElement;