'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.PROPERTY_TYPES = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

var _WithIdAndTypeHOC = require('../util/hoc/WithIdAndTypeHOC');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = exports.PROPERTY_TYPES = {
    disabled: _propTypes2.default.bool,
    handlePopupStateChange: _propTypes2.default.func,
    renderInput: _propTypes2.default.func,
    renderPopup: _propTypes2.default.func,
    attachment: _propTypes2.default.string,
    popupClassName: _propTypes2.default.string,
    animationBaseName: _propTypes2.default.string,
    animate: _propTypes2.default.bool
};
var DEFAULT_PROPS = {
    disabled: false
};

var PopupWithControl = function (_React$Component) {
    _inherits(PopupWithControl, _React$Component);

    function PopupWithControl() {
        var _temp, _this, _ret;

        _classCallCheck(this, PopupWithControl);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.handlePopupStateChange = function (open) {
            if (_this.props.disabled) {
                return;
            }

            if (_this.props.handlePopupStateChange) {
                _this.props.handlePopupStateChange(open);
            }

            if (open) {
                _this.handlePopupOpening();
            }
        }, _this.storeInputRef = function (ref) {
            return _this.inputRef = ref;
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    PopupWithControl.prototype.handlePopupOpening = function handlePopupOpening() {
        var popupContent = _reactDom2.default.findDOMNode(this.refs.popup.getContent());
        if (!this.props.popupWidth) {
            var input = _reactDom2.default.findDOMNode(this.inputRef);
            popupContent.style.width = input.offsetWidth + 'px';
        }
    };

    PopupWithControl.prototype.render = function render() {
        return _react2.default.createElement(
            _Popup2.default,
            {
                onContentDidMount: this.props.onContentDidMount,
                ref: 'popup',
                attachment: this.props.attachment,
                on: 'click',
                popupClassName: this.props.popupClassName,
                animationBaseName: this.props.animationBaseName,
                open: this.props.popupOpen,
                onPopupStateChange: this.handlePopupStateChange,
                animate: this.props.animate,
                popupWidth: this.props.popupWidth
            },
            this.props.renderInput(this.storeInputRef),
            this.props.renderPopup()
        );
    };

    return PopupWithControl;
}(_react2.default.Component);

PopupWithControl.propTypes = PROPERTY_TYPES;
PopupWithControl.defaultProps = DEFAULT_PROPS;

exports.default = (0, _WithIdAndTypeHOC.withIdAndTypeContext)(PopupWithControl, 'PopupWithControl');