'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    onChange: _propTypes2.default.func,
    label: _propTypes2.default.string,
    disabled: _propTypes2.default.bool,
    checked: _propTypes2.default.bool,
    testId: _propTypes2.default.any
};
var DEFAULT_PROPS = {};

var Radio = function (_React$Component) {
    _inherits(Radio, _React$Component);

    function Radio(props) {
        _classCallCheck(this, Radio);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.onChange = _this.onChange.bind(_this);
        return _this;
    }

    Radio.prototype.onChange = function onChange() {
        if (this.props.onChange && !this.props.disabled) {
            this.props.onChange(this.props);
        }
    };

    Radio.prototype.getRadioLabel = function getRadioLabel() {
        return this.props.label ? _react2.default.createElement(
            'span',
            { className: 'radio-label' },
            this.props.label
        ) : null;
    };

    Radio.prototype.render = function render() {
        var _this2 = this;

        var radioStyle = (0, _classnames2.default)({
            radio: true,
            disabled: this.props.disabled
        });
        var radioBtnStyle = (0, _classnames2.default)({
            'radio-btn': true,
            checked: this.props.checked
        });

        return _react2.default.createElement(
            'div',
            {
                'data-test-id': this.props.testId,
                'data-test-checked': this.props.checked,
                className: radioStyle,
                onClick: function onClick() {
                    _this2.onChange();
                }
            },
            _react2.default.createElement('span', { className: radioBtnStyle }),
            this.getRadioLabel()
        );
    };

    return Radio;
}(_react2.default.Component);

Radio.propTypes = PROPERTY_TYPES;
Radio.defaultProps = DEFAULT_PROPS;

exports.default = Radio;