'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _Radio = require('../Radio');

var _Radio2 = _interopRequireDefault(_Radio);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    onChange: _propTypes2.default.func
};
var DEFAULT_PROPS = {};

var RadioGroup = function (_React$Component) {
    _inherits(RadioGroup, _React$Component);

    function RadioGroup(props) {
        _classCallCheck(this, RadioGroup);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            radioList: []
        };
        _this.onChange = _this.onChange.bind(_this);
        return _this;
    }

    RadioGroup.prototype.componentWillMount = function componentWillMount() {
        var _this2 = this;

        var key = 0;
        var radioList = _react.Children.map(this.props.children, function (child) {
            if (child.type === _Radio2.default) {
                return _react2.default.cloneElement(child, {
                    radioKey: key++,
                    onChange: _this2.onChange
                });
            } else {
                return child;
            }
        });

        this.setState({ radioList: radioList });
    };

    RadioGroup.prototype.onChange = function onChange(_ref) {
        var radioKey = _ref.radioKey,
            checked = _ref.checked,
            data = _ref.data;

        if (checked) {
            return;
        }

        var newState = this.state.radioList.map(function (radio) {
            return _react2.default.cloneElement(radio, {
                checked: radio.props.radioKey === radioKey
            });
        });

        this.setState({ radioList: newState });

        this.props.onChange(data);
    };

    RadioGroup.prototype.render = function render() {
        var style = (0, _classnames2.default)(this.props.className, {
            'radio-group': true
        });
        return _react2.default.createElement(
            'div',
            { className: style },
            this.state.radioList
        );
    };

    return RadioGroup;
}(_react2.default.Component);

RadioGroup.propTypes = PROPERTY_TYPES;
RadioGroup.defaultProps = DEFAULT_PROPS;

exports.default = RadioGroup;