'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _keyCodes = require('../util/constant/key-codes');

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

var _findIndex = require('lodash/findIndex');

var _findIndex2 = _interopRequireDefault(_findIndex);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var STEP_BACK = -1;
var STEP_FORWARD = 1;

exports.default = function (isMulti) {
    return function keyBoardNav(Wrapper) {
        var Enhance = function (_Wrapper) {
            _inherits(Enhance, _Wrapper);

            _createClass(Enhance, null, [{
                key: 'displayName',
                get: function get() {
                    return Wrapper.displayName || Wrapper.name;
                }
            }]);

            function Enhance(props) {
                _classCallCheck(this, Enhance);

                var _this = _possibleConstructorReturn(this, _Wrapper.call(this, props));

                var index = _this._findOptionIndex(_this.props.value, _this.props.options);
                _this._optionIndex = index >= 0 ? index : null;
                _this.state = _extends({}, _this.state, {
                    tempSelection: _this.props.options[_this._optionIndex]
                });
                return _this;
            }

            //API


            Enhance.prototype.resetNav = function resetNav() {
                this.setState({
                    tempSelection: null
                });
                this._optionIndex = null;
            };

            Enhance.prototype.navigate = function navigate(e, option) {
                switch (e && e.keyCode) {
                    case _keyCodes.KeyCode.ENTER:
                        _Wrapper.prototype.select.call(this, this.state.tempSelection);
                        break;

                    case _keyCodes.KeyCode.UP_ARROW:
                        this._stopEvent(e);

                        this._optionIndex = this._getNextOptionIndex(STEP_BACK);
                        this._setTempOption(this._optionIndex);
                        break;
                    case _keyCodes.KeyCode.DOWN_ARROW:
                        this._stopEvent(e);

                        this._optionIndex = this._getNextOptionIndex(STEP_FORWARD);
                        this._setTempOption(this._optionIndex);
                        break;
                }
                if (option) {
                    this._changeTarget(option);
                }
            };

            Enhance.prototype._stopEvent = function _stopEvent(event) {
                event.stopPropagation();
                event.preventDefault();
            };

            Enhance.prototype._findById = function _findById(options, id) {
                return (0, _find2.default)(options, function (option) {
                    return option && option.id === id;
                });
            };

            Enhance.prototype._setTempOption = function _setTempOption(index) {
                var _this2 = this;

                this.setState({
                    tempSelection: _Wrapper.prototype.getOptions.call(this)[index]
                }, function () {
                    var el = _this2._getSelectedOptionEl();
                    el && el.focus && el.focus();

                    var input = _Wrapper.prototype.getInput.call(_this2);
                    input && input.focus && input.focus();
                });
            };

            Enhance.prototype._getInitialIndex = function _getInitialIndex(step) {
                if (step === STEP_FORWARD) {
                    return 0;
                } else if (step === STEP_BACK) {
                    return this._optionLength() - 1;
                }
            };

            Enhance.prototype._getNextOptionIndex = function _getNextOptionIndex(step) {
                if (this._optionIndex === null) {
                    return this._getInitialIndex(step);
                }

                var futureStep = this._optionIndex + step;
                if (isMulti && (futureStep < 0 || futureStep > this._getOptions().length - 1)) {
                    return this._optionIndex;
                }

                this._optionIndex += step;

                if (this._optionIndex >= this._optionLength() || this._optionIndex < 0) {
                    this._optionIndex = this._getInitialIndex(step);
                }

                return this._optionIndex;
            };

            Enhance.prototype._optionLength = function _optionLength() {
                return this._getOptions().length;
            };

            Enhance.prototype._select = function _select(option) {
                if (!option) {
                    return;
                }
                _Wrapper.prototype.select.call(this, option);
            };

            Enhance.prototype._getSelectedOptionEl = function _getSelectedOptionEl() {
                return _Wrapper.prototype.getSelectedOptionEl.call(this);
            };

            Enhance.prototype._getOptions = function _getOptions() {
                return this.state.filtered;
            };

            Enhance.prototype._findOptionIndex = function _findOptionIndex(id) {
                var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

                return (0, _findIndex2.default)(options, function (option) {
                    return id === option.id;
                });
            };

            Enhance.prototype._changeTarget = function _changeTarget(target) {
                this._optionIndex = this._findOptionIndex(target.id, this._getOptions());
                this.setState({
                    tempSelection: target
                });
            };

            return Enhance;
        }(Wrapper);

        return Enhance;
    };
};