'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _Select = require('./Select');

var _Select2 = _interopRequireDefault(_Select);

var _addonKnobs = require('@storybook/addon-knobs');

var _SelectInput = require('./SelectInput');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function generateOptions(name, amount) {
    var result = [];
    for (var i = 0; i < amount; i++) {
        result.push({
            id: i,
            displayString: name + ' ' + i,
            className: i % 2 ? 'odd' : 'even'
        });
    }

    result.push({
        id: 9999,
        displayString: 'Amsterdam (NL)'
    });
    return result;
}

var options = generateOptions('Robot', 1000);

(0, _react3.storiesOf)('Select', module).add('uncontrolled', function () {
    return _react2.default.createElement(_Select2.default, { options: options });
}).add('with special options', function () {
    return _react2.default.createElement(_Select2.default, { options: options });
}).add('controlled', function () {
    return _react2.default.createElement(_Select2.default, { open: (0, _addonKnobs.boolean)('Open', true), options: options });
}).add('with search', function () {
    return _react2.default.createElement(_Select2.default, { search: true, options: options });
}).add('disabled', function () {
    return _react2.default.createElement(_Select2.default, { options: options, disabled: true });
}).add('with custom input', function () {
    return _react2.default.createElement(_Select2.default, {
        options: options,
        Input: function Input(props) {
            return _react2.default.createElement(_SelectInput.SelectLabelInput, _extends({}, props, { text: 'Select options' }));
        },
        testId: 'test-id-check',
        popup: {
            attachment: 'bottom left',
            width: 600,
            className: 'tree-select__popup popover'
        }
    });
});