'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _values, _options, _groupView, _value2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _GroupedMultiSelect = require('./GroupedMultiSelect.js');

var _GroupedMultiSelect2 = _interopRequireDefault(_GroupedMultiSelect);

var _ButtonGroup = require('../../Button/ButtonGroup');

var _ButtonGroup2 = _interopRequireDefault(_ButtonGroup);

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function generateOptions(name, amount) {
    var result = [];
    for (var i = 0; i < amount; i++) {
        result.push({
            id: i,
            displayString: name + ' ' + i
        });
    }
    return result;
}

var teamKey = 'Teams';
var personKey = 'Persons';

var teams = {
    value: [1, 2, 3],
    options: generateOptions('Teamsrrp', 5)
};
var persons = {
    value: [3, 5, 10],
    options: generateOptions('Personsrr', 100)
};
var companies = {
    value: [3, 5, 10],
    options: generateOptions('Company ', 100)
};

var values = (_values = {}, _defineProperty(_values, teamKey, teams.value), _defineProperty(_values, personKey, persons.value), _values);
var options = (_options = {}, _defineProperty(_options, teamKey, teams.options), _defineProperty(_options, personKey, persons.options), _options);

var TestForm = function (_React$Component) {
    _inherits(TestForm, _React$Component);

    function TestForm() {
        var _temp, _this, _ret;

        _classCallCheck(this, TestForm);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.onSave = function () {
            console.log('on save');
        }, _this.onBack = function () {
            console.log('go back');
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    TestForm.prototype.componentWillMount = function componentWillMount() {
        this.props.methodCallback(this.onSave, this.onBack);
    };

    TestForm.prototype.render = function render() {
        return _react2.default.createElement(
            'div',
            null,
            'Test Case'
        );
    };

    return TestForm;
}(_react2.default.Component);

var TeamGroupHeader = function (_React$Component2) {
    _inherits(TeamGroupHeader, _React$Component2);

    function TeamGroupHeader() {
        _classCallCheck(this, TeamGroupHeader);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    TeamGroupHeader.prototype.render = function render() {
        return _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
                'span',
                null,
                'Teams'
            )
        );
    };

    return TeamGroupHeader;
}(_react2.default.Component);

var groupView = (_groupView = {}, _defineProperty(_groupView, teamKey, {
    header: TeamGroupHeader,
    noOptionPlaceholder: _react2.default.createElement(
        'span',
        null,
        'There are no teams yet'
    ),
    extra: function extra(option) {
        return _react2.default.createElement(
            'span',
            null,
            option.id
        );
    }
}), _defineProperty(_groupView, personKey, {
    noOptionPlaceholder: _react2.default.createElement(
        'span',
        null,
        'No options passed'
    )
}), _groupView);

var SimpleExample = function (_React$Component3) {
    _inherits(SimpleExample, _React$Component3);

    function SimpleExample(props) {
        var _value;

        _classCallCheck(this, SimpleExample);

        var _this3 = _possibleConstructorReturn(this, _React$Component3.call(this, props));

        _this3._onChange = function (values) {
            _this3.setState({
                value: values
            });
        };

        _this3.state = {
            value: (_value = {}, _defineProperty(_value, teamKey, [1, 2]), _defineProperty(_value, personKey, []), _value),
            options: options
        };
        return _this3;
    }

    SimpleExample.prototype.render = function render() {
        return _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_GroupedMultiSelect2.default, {
                showSubSection: this.props.sub,
                subSection: TestForm,
                placeholder: 'This is placeholder',
                onChange: this._onChange,
                groupView: groupView,
                keys: [teamKey, personKey],
                options: options,
                value: this.state.value
            })
        );
    };

    return SimpleExample;
}(_react2.default.Component);

var MultiValues = {
    one: {
        value: (_value2 = {}, _defineProperty(_value2, teamKey, [1, 2]), _defineProperty(_value2, personKey, []), _value2),
        keys: [teamKey, personKey]
    },
    two: {
        value: {
            companies: [123]
        },
        keys: ['companies']
    }
};

var ChangingContent = function (_React$Component4) {
    _inherits(ChangingContent, _React$Component4);

    function ChangingContent(props) {
        _classCallCheck(this, ChangingContent);

        var _this4 = _possibleConstructorReturn(this, _React$Component4.call(this, props));

        _this4._onChange = function (values) {
            var state = _this4.state.value[_this4.state.selected];
            _this4.setState({
                value: _extends({}, _this4.state.value, _defineProperty({}, _this4.state.selected, _extends({}, state, { value: values })))
            });
        };

        _this4.selectTab = function (selected) {
            return function () {
                _this4.setState({ selected: selected });
            };
        };

        _this4.state = {
            value: MultiValues,
            selected: 'one',
            options: options
        };
        return _this4;
    }

    ChangingContent.prototype.render = function render() {
        var _this5 = this;

        var multi = MultiValues[this.state.selected];
        var value = this.state.value[this.state.selected].value;
        return _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(_GroupedMultiSelect2.default, {
                placeholder: 'This is placeholder',
                onChange: this._onChange,
                groupView: groupView,
                keys: multi.keys,
                options: _extends({ companies: companies.options }, options),
                value: value,
                popupHeader: _react2.default.createElement(
                    'div',
                    { style: { display: 'flex', flex: '1 1 0', padding: '3px' } },
                    _react2.default.createElement(
                        _ButtonGroup2.default,
                        null,
                        Object.keys(MultiValues).map(function (key) {
                            return _react2.default.createElement(_Button2.default, {
                                value: key.toLocaleUpperCase(),
                                className: 'btn--grouped',
                                selected: _this5.state.selected === key,
                                onClick: _this5.selectTab(key)
                            });
                        })
                    )
                )
            })
        );
    };

    return ChangingContent;
}(_react2.default.Component);

(0, _react3.storiesOf)('Grouped MultiSelect(controlled)', module).add('basic', function () {
    return _react2.default.createElement(SimpleExample, { sub: false });
});

(0, _react3.storiesOf)('Grouped MultiSelect(controlled)', module).add('subsection', function () {
    return _react2.default.createElement(SimpleExample, { sub: true });
});

(0, _react3.storiesOf)('Grouped MultiSelect', module).add('subsection', function () {
    return _react2.default.createElement(ChangingContent, { sub: true });
});
(0, _react3.storiesOf)('Grouped MultiSelect', module).add('With content', function () {
    return _react2.default.createElement(ChangingContent, null);
});