'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.MultiSelectInput = exports.SingleSelectInput = exports.SelectLabelInput = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Button = require('../Button');

var _Button2 = _interopRequireDefault(_Button);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Popup = require('../Popup');

var _Popup2 = _interopRequireDefault(_Popup);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SelectLabelInput = exports.SelectLabelInput = function (_React$Component) {
    _inherits(SelectLabelInput, _React$Component);

    function SelectLabelInput() {
        _classCallCheck(this, SelectLabelInput);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    SelectLabelInput.prototype.render = function render() {
        var _props = this.props,
            text = _props.text,
            inputRef = _props.inputRef,
            onClick = _props.onClick;


        var testId = this.props.testId || this.context.testId;

        return _react2.default.createElement(_Button2.default, { onClick: onClick, testId: testId, ref: inputRef, className: 'btn-link btn-m btn', value: text });
    };

    return SelectLabelInput;
}(_react2.default.Component);

SelectLabelInput.propTypes = {
    text: _propTypes2.default.string,
    testId: _propTypes2.default.string,
    inputRef: _propTypes2.default.func,
    onClick: _propTypes2.default.func
};
SelectLabelInput.contextTypes = {
    testId: _propTypes2.default.string
};

var SingleSelectInput = exports.SingleSelectInput = function (_React$Component2) {
    _inherits(SingleSelectInput, _React$Component2);

    function SingleSelectInput() {
        _classCallCheck(this, SingleSelectInput);

        return _possibleConstructorReturn(this, _React$Component2.apply(this, arguments));
    }

    SingleSelectInput.prototype.render = function render() {
        var _props2 = this.props,
            id = _props2.id,
            value = _props2.value,
            inputRef = _props2.inputRef,
            onClick = _props2.onClick,
            onKeyDown = _props2.onKeyDown,
            className = _props2.className;


        var testId = this.props.testId || this.context.testId;

        return _react2.default.createElement(
            'div',
            {
                onKeyDown: onKeyDown,
                id: id,
                ref: inputRef,
                tabIndex: '0',
                className: className,
                onClick: onClick,
                'data-test-id': testId
            },
            _react2.default.createElement(
                'div',
                { title: value },
                value
            ),
            _react2.default.createElement('i', { className: 'im icon-arrow-down' })
        );
    };

    return SingleSelectInput;
}(_react2.default.Component);

SingleSelectInput.propTypes = {
    id: _propTypes2.default.string,
    text: _propTypes2.default.string,
    testId: _propTypes2.default.string,
    inputRef: _propTypes2.default.func,
    onClick: _propTypes2.default.func
};
SingleSelectInput.contextTypes = {
    testId: _propTypes2.default.string
};

var MultiSelectInput = exports.MultiSelectInput = function (_React$Component3) {
    _inherits(MultiSelectInput, _React$Component3);

    function MultiSelectInput() {
        var _temp, _this3, _ret;

        _classCallCheck(this, MultiSelectInput);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this3 = _possibleConstructorReturn(this, _React$Component3.call.apply(_React$Component3, [this].concat(args))), _this3), _this3.handleTooltipStateChange = function (open) {
            if (_this3.props.value.length > 0) {
                _this3.props.handleTooltipStateChange(open);
            } else {
                _this3.props.handleTooltipStateChange(false);
            }
        }, _temp), _possibleConstructorReturn(_this3, _ret);
    }

    MultiSelectInput.prototype.render = function render() {
        var _props3 = this.props,
            onClick = _props3.onClick,
            value = _props3.value,
            id = _props3.id,
            inputRef = _props3.inputRef,
            tooltipOpen = _props3.tooltipOpen;


        var testId = this.props.testId || this.context.testId;

        var className = (0, _classnames2.default)(this.props.className, 'select', {
            placeholder: value.length === 0,
            disabled: this.props.disabled
        });

        return _react2.default.createElement(
            _Popup2.default,
            {
                attachment: 'bottom left',
                on: 'hover',
                popupClassName: 'tooltip',
                open: tooltipOpen,
                onPopupStateChange: this.handleTooltipStateChange,
                onClick: onClick
            },
            _react2.default.createElement(
                'div',
                { id: id, ref: inputRef, tabIndex: '0', className: className, 'data-test-id': testId },
                _react2.default.createElement(
                    'div',
                    null,
                    this.getText()
                ),
                _react2.default.createElement('i', { className: 'im icon-arrow-down' })
            ),
            _react2.default.createElement(
                'div',
                null,
                value.map(function (option) {
                    return _react2.default.createElement(
                        'div',
                        { key: 'tooltip-' + option.id },
                        option.displayString
                    );
                })
            )
        );
    };

    MultiSelectInput.prototype.getText = function getText() {
        if (this.props.value.length === 0) {
            return this.props.placeholder;
        } else {
            return this.props.getText(this.props.value);
        }
    };

    return MultiSelectInput;
}(_react2.default.Component);

MultiSelectInput.propTypes = {
    value: _propTypes2.default.array,
    id: _propTypes2.default.any,
    inputRef: _propTypes2.default.func,
    className: _propTypes2.default.string,
    placeholder: _propTypes2.default.string,
    testId: _propTypes2.default.string,
    getText: _propTypes2.default.func,
    dislabed: _propTypes2.default.bool,

    tooltipOpen: _propTypes2.default.bool,
    handleTooltipStateChange: _propTypes2.default.func,
    onClick: _propTypes2.default.func
};
MultiSelectInput.defaultProps = {
    placeholder: 'Select...',
    getText: function getText(selectedOptions) {
        return selectedOptions.length + ' item(s) selected';
    }
};
MultiSelectInput.contextTypes = {
    testId: _propTypes2.default.string
};