'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactList = require('react-list');

var _reactList2 = _interopRequireDefault(_reactList);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _CheckBox = require('../CheckBox');

var _CheckBox2 = _interopRequireDefault(_CheckBox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var REACT_PROPS = {
    noOptionPlaceholder: _propTypes2.default.element,
    extra: _propTypes2.default.func,
    isSelected: _propTypes2.default.func.isRequired,
    options: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        id: _propTypes2.default.number,
        displayString: _propTypes2.default.string
    })),
    onChange: _propTypes2.default.func
};

var DEF_PROPS = {
    options: [],
    type: 'unknown type',
    extra: function extra() {
        return null;
    },
    noOptionPlaceholder: _react2.default.createElement('div', null),
    onChange: function onChange() {},
    isSelected: function isSelected() {}
};

var SelectionList = function (_React$Component) {
    _inherits(SelectionList, _React$Component);

    function SelectionList(props) {
        _classCallCheck(this, SelectionList);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this._renderOptions = _this._renderOptions.bind(_this);
        _this._renderOption = _this._renderOption.bind(_this);
        _this._onOptionSelect = _this._onOptionSelect.bind(_this);
        return _this;
    }

    SelectionList.prototype._onOptionSelect = function _onOptionSelect(option, type) {
        this.props.onChange(option, type);
    };

    SelectionList.prototype._renderOption = function _renderOption(index, key) {
        var _this2 = this;

        var option = this.props.options[index];
        var style = (0, _classnames2.default)('check-box-list__item');
        return _react2.default.createElement(
            'tr',
            { className: style, tabIndex: '0', key: key, onClick: function onClick() {
                    return _this2._onOptionSelect(option);
                } },
            _react2.default.createElement(
                'td',
                { className: 'check-box-list__check-box' },
                _react2.default.createElement(_CheckBox2.default, { value: this.props.isSelected(option, this.props.type) })
            ),
            _react2.default.createElement(
                'td',
                { className: 'check-box-list__label' },
                _react2.default.createElement(
                    'div',
                    { className: 'check-box-list__extra', onClick: function onClick(e) {
                            return e.stopPropagation();
                        } },
                    this.props.extra(option)
                ),
                _react2.default.createElement(
                    'span',
                    { className: 'check-box-list__item-text', title: option.displayString },
                    option.displayString
                )
            )
        );
    };

    SelectionList.prototype._renderOptions = function _renderOptions(options, ref) {
        return _react2.default.createElement(
            'table',
            { className: 'check-box-list__table' },
            _react2.default.createElement(
                'colgroup',
                null,
                _react2.default.createElement('col', { className: 'check-box-list__check-box-column' }),
                _react2.default.createElement('col', null)
            ),
            _react2.default.createElement(
                'tbody',
                { ref: ref },
                options
            )
        );
    };

    SelectionList.prototype.render = function render() {
        if (this.props.options.length === 0) {
            return this.props.noOptionPlaceholder;
        }

        return _react2.default.createElement(_reactList2.default, {
            itemRenderer: this._renderOption,
            itemsRenderer: this._renderOptions,
            length: this.props.options.length,
            type: 'uniform'
        });
    };

    return SelectionList;
}(_react2.default.Component);

SelectionList.propTypes = REACT_PROPS;
SelectionList.defaultProps = DEF_PROPS;

exports.default = SelectionList;