'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _isUndefined = require('lodash/isUndefined');

var _isUndefined2 = _interopRequireDefault(_isUndefined);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROP_TYPES = {
    disable: _propTypes2.default.bool,
    checked: _propTypes2.default.bool,
    title: _propTypes2.default.string,
    testId: _propTypes2.default.any
};

var DEFAULT_PROPS = {
    disabled: false,
    onChange: function onChange() {}
};

var Switch = function (_React$Component) {
    _inherits(Switch, _React$Component);

    function Switch(props) {
        _classCallCheck(this, Switch);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this.state = {
            checked: _this.props.checked
        };
        _this._handleOnChange = _this._handleOnChange.bind(_this);
        return _this;
    }

    Switch.prototype._isControlled = function _isControlled() {
        return !(0, _isUndefined2.default)(this.props.value);
    };

    Switch.prototype._handleOnChange = function _handleOnChange(event) {
        var _this2 = this;

        if (this.props.disabled) {
            return;
        }
        if (this._isControlled()) {
            this.props.onChange(!this.props.value, event);
        } else {
            this.setState(function (prevState, props) {
                return {
                    checked: !_this2.state.checked
                };
            }, function () {
                _this2.props.onChange(_this2.state.checked, event);
            });
        }
    };

    Switch.prototype._isChecked = function _isChecked() {
        return this._isControlled() ? this.props.value : this.state.checked;
    };

    Switch.prototype._getTitle = function _getTitle() {
        return (0, _isUndefined2.default)(this.props.title) ? null : _react2.default.createElement(
            'label',
            { className: 'ros-switch__title' },
            this.props.title
        );
    };

    Switch.prototype.render = function render() {
        var checked = this._isChecked();

        var classNames = (0, _classnames2.default)('ros-switch', {
            disabled: this.props.disabled,
            checked: checked
        });

        return _react2.default.createElement(
            'div',
            {
                'data-test-id': this.props.testId,
                'data-test-checked': checked,
                onClick: this._handleOnChange,
                className: classNames
            },
            _react2.default.createElement(
                'span',
                { className: 'ros-switch__control' },
                _react2.default.createElement('i', null)
            ),
            this._getTitle()
        );
    };

    return Switch;
}(_react2.default.Component);

Switch.propTypes = PROP_TYPES;
Switch.defaultProps = DEFAULT_PROPS;

exports.default = Switch;