'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    item: _propTypes2.default.any,
    rowProps: _propTypes2.default.any
};
var DEFAULT_PROPS = {};

var Row = function (_React$Component) {
    _inherits(Row, _React$Component);

    function Row(props) {
        _classCallCheck(this, Row);

        return _possibleConstructorReturn(this, _React$Component.call(this, props));
    }

    Row.prototype.shouldComponentUpdate = function shouldComponentUpdate(nextProps, nextState) {
        if (nextProps.className !== this.props.className) {
            return true;
        }
        return nextProps.item !== this.props.item;
    };

    Row.prototype.render = function render() {
        var _this2 = this;

        return _react2.default.createElement(
            'tr',
            _extends({
                className: this.props.className,
                onClick: function onClick(e) {
                    return _this2.props.onClick && _this2.props.onClick(e);
                }
            }, this.props.rowProps),
            this.props.children
        );
    };

    return Row;
}(_react2.default.Component);

Row.propTypes = PROPERTY_TYPES;
Row.defaultProps = DEFAULT_PROPS;

exports.default = Row;