'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    tabId: _propTypes2.default.any,
    value: _propTypes2.default.string,
    onEnter: _propTypes2.default.func,
    onChange: _propTypes2.default.func,
    testId: _propTypes2.default.any
};
var DEFAULT_PROPS = {};

var Tab = function (_React$Component) {
    _inherits(Tab, _React$Component);

    function Tab() {
        _classCallCheck(this, Tab);

        return _possibleConstructorReturn(this, _React$Component.apply(this, arguments));
    }

    Tab.prototype.componentWillMount = function componentWillMount() {
        if (this._isSelected() && this.props.onEnter) {
            this.props.onEnter();
        }
    };

    Tab.prototype._isSelected = function _isSelected() {
        return this.props.selected === this.props.tabId;
    };

    Tab.prototype._onChange = function _onChange() {
        this.props.onChange(this.props.tabId);
    };

    Tab.prototype.render = function render() {
        var _this2 = this;

        var _props = this.props,
            className = _props.className,
            children = _props.children,
            value = _props.value;

        var style = (0, _classnames2.default)('ros-tabs__tab', className, {
            'ros-tab--selected': this._isSelected()
        });

        return _react2.default.createElement(
            'div',
            { 'data-test-id': this.props.testId, className: style, onClick: function onClick() {
                    return _this2._onChange();
                } },
            _react2.default.createElement(
                'span',
                null,
                value || children
            )
        );
    };

    return Tab;
}(_react2.default.Component);

Tab.propTypes = PROPERTY_TYPES;
Tab.defaultProps = DEFAULT_PROPS;

exports.default = Tab;