'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Tab = require('./Tab/Tab');

var _Tab2 = _interopRequireDefault(_Tab);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    onChange: _propTypes2.default.func,
    onBeforeChange: _propTypes2.default.func,
    selected: _propTypes2.default.any,
    testId: _propTypes2.default.any
};

var DEFAULT_PROPS = {};

var Tabs = function (_React$Component) {
    _inherits(Tabs, _React$Component);

    function Tabs(props) {
        _classCallCheck(this, Tabs);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        _this._onChange = _this._onChange.bind(_this);
        return _this;
    }

    Tabs.prototype._renderTabs = function _renderTabs() {
        var _this2 = this;

        return _react2.default.Children.map(this.props.children, function (tab, index) {
            return _react2.default.cloneElement(tab, {
                key: index,
                onChange: _this2._onChange,
                selected: _this2.props.selected
            });
        });
    };

    Tabs.prototype._onChange = function _onChange(tabId) {
        var _this3 = this;

        if (this.props.onBeforeChange) {
            this.props.onBeforeChange(tabId, function () {
                _this3.props.onChange(tabId);
            });
        } else {
            this.props.onChange(tabId);
        }
    };

    Tabs.prototype.render = function render() {
        var style = (0, _classnames2.default)('ros-tabs', this.props.className, {
            disabled: this.props.disabled
        });

        return _react2.default.createElement(
            'div',
            { 'data-test-id': this.props.testId, className: style },
            this._renderTabs()
        );
    };

    return Tabs;
}(_react2.default.Component);

Tabs.propTypes = PROPERTY_TYPES;
Tabs.defaultProps = DEFAULT_PROPS;
Tabs.Tab = _Tab2.default;

exports.default = Tabs;