'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _utils = require('../util/utils');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROPERTY_TYPES = {
    placeholder: _propTypes2.default.string,
    value: _propTypes2.default.any,
    maxLength: _propTypes2.default.number,
    testId: _propTypes2.default.any
};
var DEFAULT_PROPS = {};

var TextArea = function (_React$Component) {
    _inherits(TextArea, _React$Component);

    function TextArea(props) {
        _classCallCheck(this, TextArea);

        var _this = _possibleConstructorReturn(this, _React$Component.call(this, props));

        if (!_this.isControlled()) {
            _this.state = {
                value: ''
            };
        }
        _this.update = _this.update.bind(_this);
        return _this;
    }

    TextArea.prototype.getValue = function getValue() {
        return this.refs.textarea.value;
    };

    TextArea.prototype.update = function update(e) {
        var value = e.target.value;
        if (!this.isControlled()) {
            this.setState({
                value: value
            });
        }
        if (this.props.onChange && !this.props.disabled) {
            this.props.onChange(value);
        }
    };

    TextArea.prototype.isControlled = function isControlled() {
        return (0, _utils.isDefined)(this.props.value);
    };

    TextArea.prototype.render = function render() {
        var _this2 = this;

        var style = (0, _classnames2.default)(this.props.className, 'textarea', {
            disabled: this.props.disabled
        });

        return _react2.default.createElement(
            'div',
            { className: style },
            _react2.default.createElement('textarea', {
                'data-test-id': this.props.testId,
                ref: 'textarea',
                value: this.isControlled() ? this.props.value : this.state.value,
                onChange: function onChange(e) {
                    return _this2.update(e);
                },
                placeholder: this.props.placeholder,
                onBlur: this.props.onBlur,
                maxLength: this.props.maxLength
            })
        );
    };

    return TextArea;
}(_react2.default.Component);

TextArea.propTypes = PROPERTY_TYPES;
TextArea.defaultProps = DEFAULT_PROPS;

exports.default = TextArea;