'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SingleTreeSelect = exports.TreeWithInactiveSwitch = exports.TreeSelect = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _MultiSelect = require('../MultiSelect/MultiSelect');

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _CheckBox = require('../CheckBox');

var _CheckBox2 = _interopRequireDefault(_CheckBox);

var _PopupWithControl = require('../Popup/PopupWithControl');

var _PopupWithControl2 = _interopRequireDefault(_PopupWithControl);

var _SelectInput = require('../Select/SelectInput');

var _TreeSelectContent = require('./TreeSelectContent');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TREE_PROPS = _extends({}, _MultiSelect.PROPERTY_TYPES, {
    hashLength: _propTypes2.default.number.isRequired,
    renderHeader: _propTypes2.default.func,
    footer: _propTypes2.default.node,
    testId: _propTypes2.default.string
});

var TreeSelect = exports.TreeSelect = function (_React$Component) {
    _inherits(TreeSelect, _React$Component);

    function TreeSelect() {
        _classCallCheck(this, TreeSelect);

        for (var _len = arguments.length, r = Array(_len), _key = 0; _key < _len; _key++) {
            r[_key] = arguments[_key];
        }

        var _this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(r)));

        _this.state = {
            popupOpen: false,
            tooltipOpen: false
        };

        _this.doChange = function (value) {
            _this.setState({ value: value }, _this.sync);
        };

        _this.sync = function () {
            _this.props.onChange(_this.state.value);
        };

        _this.handlePopupStateChange = function (open) {
            _this.setState(function (prevState) {
                return {
                    popupOpen: open,
                    tooltipOpen: open ? false : prevState.tooltipOpen
                };
            });
        };

        _this.handleTooltipStateChange = function (open) {
            _this.setState(function (prevState) {
                return {
                    tooltipOpen: prevState.popupOpen ? false : open
                };
            });
        };

        _this.renderInput = function (inputRef) {
            return React.createElement(_SelectInput.MultiSelectInput, {
                className: _this.props.className,
                value: _this.props.options.filter(function (option) {
                    return _this.state.value.find(function (val) {
                        return val === option.id;
                    });
                }),
                dislabed: _this.props.disabled,
                tooltipOpen: _this.state.tooltipOpen,
                handleTooltipStateChange: _this.handleTooltipStateChange,
                testId: _this.props.testId,
                inputRef: inputRef
            });
        };

        _this.renderPopup = function () {
            return React.createElement(_TreeSelectContent.MultiTreeSelectContent, {
                hashLength: _this.props.hashLength,
                value: _this.state.value,
                options: _this.props.options,
                onChange: _this.doChange,
                footer: _this.props.footer,
                highlightBroken: _this.props.highlightBroken
            });
        };

        _this.state.value = _this.props.value || [];
        return _this;
    }

    TreeSelect.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        if (nextProps.value && this.state.value !== nextProps.value) {
            this.setState({ value: nextProps.value });
        }
    };

    TreeSelect.prototype.render = function render() {
        return React.createElement(_PopupWithControl2.default, {
            popupOpen: this.state.popupOpen,
            handlePopupStateChange: this.handlePopupStateChange,
            attachment: 'bottom left',
            popupClassName: 'select__popover',
            animationBaseName: 'select__popover--animation-slide-y',
            renderInput: this.renderInput,
            renderPopup: this.renderPopup,
            testId: this.props.testId
        });
    };

    return TreeSelect;
}(React.Component);

TreeSelect.propTypes = _extends({}, TREE_PROPS);
TreeSelect.defaultProps = {
    onChange: _noop2.default
};

var TreeWithInactiveSwitch = exports.TreeWithInactiveSwitch = function (_React$Component2) {
    _inherits(TreeWithInactiveSwitch, _React$Component2);

    function TreeWithInactiveSwitch() {
        _classCallCheck(this, TreeWithInactiveSwitch);

        for (var _len2 = arguments.length, r = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            r[_key2] = arguments[_key2];
        }

        var _this2 = _possibleConstructorReturn(this, _React$Component2.call.apply(_React$Component2, [this].concat(r)));

        _this2.state = {
            showInactive: false,
            value: []
        };

        _this2.setVisibility = function (value) {
            _this2.setState(function (prevState) {
                return {
                    showInactive: value,
                    value: value ? prevState.value : prevState.value.filter(function (prevValue) {
                        var option = _this2.props.options.find(function (option) {
                            return option.id === prevValue;
                        });
                        return option && option.active;
                    })
                };
            });
        };

        _this2.doChange = function (value) {
            _this2.setState({ value: value }, _this2.sync);
        };

        _this2.sync = function () {
            _this2.props.onChange(_this2.state.value);
        };

        _this2.state.value = _this2.props.value;
        return _this2;
    }

    TreeWithInactiveSwitch.prototype.componentWillReceiveProps = function componentWillReceiveProps(nextProps) {
        if (this.state.value !== nextProps.value) {
            this.setState({ value: nextProps.value });
        }
    };

    TreeWithInactiveSwitch.prototype.render = function render() {
        var _this3 = this;

        return React.createElement(TreeSelect, _extends({}, this.props, {
            options: this.props.options.filter(function (o) {
                return _this3.state.showInactive || o.active;
            }),
            value: this.state.value,
            onChange: this.doChange,
            footer: React.createElement(_CheckBox2.default, { onChange: this.setVisibility, value: this.state.showInactive, label: this.props.label }),
            highlightBroken: this.props.highlightBroken
        }));
    };

    return TreeWithInactiveSwitch;
}(React.Component);

TreeWithInactiveSwitch.propTypes = _extends({}, TREE_PROPS, {
    label: _propTypes2.default.node
});
TreeWithInactiveSwitch.defaultProps = {
    label: 'Display inactive',
    onChange: _noop2.default
};

var SingleTreeSelect = exports.SingleTreeSelect = function (_React$Component3) {
    _inherits(SingleTreeSelect, _React$Component3);

    function SingleTreeSelect() {
        var _temp, _this4, _ret;

        _classCallCheck(this, SingleTreeSelect);

        for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
            args[_key3] = arguments[_key3];
        }

        return _ret = (_temp = (_this4 = _possibleConstructorReturn(this, _React$Component3.call.apply(_React$Component3, [this].concat(args))), _this4), _this4.state = {
            popupOpen: false
        }, _this4.doChange = function (value) {
            _this4.setState({
                popupOpen: false
            });

            _this4.props.onChange(value);
        }, _this4.handlePopupStateChange = function (open) {
            _this4.setState({ popupOpen: open });

            if (_this4.props.onPopupStateChange) {
                _this4.props.onPopupStateChange(open);
            }
        }, _this4.renderInput = function (inputRef) {
            return React.createElement(_SelectInput.SelectLabelInput, { text: _this4.props.label, testId: _this4.props.testId, inputRef: inputRef });
        }, _this4.renderPopup = function () {
            return React.createElement(_TreeSelectContent.SingleTreeSelectContent, {
                hashLength: _this4.props.hashLength,
                value: _this4.props.value,
                options: _this4.props.options,
                onChange: _this4.doChange,
                footer: _this4.props.footer,
                highlightBroken: _this4.props.highlightBroken,
                sort: _this4.props.sort
            });
        }, _temp), _possibleConstructorReturn(_this4, _ret);
    }

    SingleTreeSelect.prototype.render = function render() {
        return React.createElement(_PopupWithControl2.default, {
            popupOpen: this.state.popupOpen,
            handlePopupStateChange: this.handlePopupStateChange,
            popupWidth: this.props.popupWidth,
            attachment: this.props.attachment,
            popupClassName: this.props.popupClassName,
            renderInput: this.renderInput,
            renderPopup: this.renderPopup,
            testId: this.props.testId
        });
    };

    return SingleTreeSelect;
}(React.Component);

SingleTreeSelect.propTypes = _extends({}, TREE_PROPS, {
    label: _propTypes2.default.string,
    popupWidth: _propTypes2.default.number,
    attachment: _propTypes2.default.string,
    popupClassName: _propTypes2.default.string,
    onPopupStateChange: _propTypes2.default.func,
    sort: _propTypes2.default.func
});
SingleTreeSelect.defaultProps = {
    onChange: _noop2.default,
    popupWidth: 600,
    attachment: 'bottom right',
    popupClassName: 'tree-select__popup popover'
};