'use strict';

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _react3 = require('@storybook/react');

var _noop = require('lodash/noop');

var _noop2 = _interopRequireDefault(_noop);

var _TreeSelect = require('./TreeSelect');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var nextId = 0;
var makeOption = function makeOption(displayString, treeNodeHash, leaf) {
    var active = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : true;
    var id = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;

    nextId++;
    return {
        id: id === null ? nextId : id,
        displayString: displayString,
        treeNodeHash: treeNodeHash,
        leaf: leaf,
        active: active
    };
};
var options = [makeOption('A Test 1', '1'), makeOption('B Test 11', '11', true, false), makeOption('C Test 12', '12', false), makeOption('D Test 121', '121', true), makeOption('X Test 13', '3', true, false, -1), makeOption('E Test 2', '2'), makeOption('F Test 21', '21', true)];

(0, _react3.storiesOf)('TreeSelect', module).add('basic', function () {
    return _react2.default.createElement(_TreeSelect.TreeSelect, { hashLength: 1, options: options, onChange: _noop2.default });
}).add('showActive', function () {
    return _react2.default.createElement(_TreeSelect.TreeWithInactiveSwitch, { hashLength: 1, options: options, value: [4] });
}).add('single select', function () {
    return _react2.default.createElement(
        'div',
        { style: { textAlign: 'center' } },
        _react2.default.createElement(_TreeSelect.SingleTreeSelect, {
            hashLength: 1,
            options: options,
            onChange: (0, _react3.action)('onChange'),
            label: '+ Add Org. Unit',
            sort: function sort(a, b) {
                if (a.id === -1) {
                    return -1;
                }
                if (b.id === 1) {
                    return 1;
                }
                return a.displayString.localeCompare(b.displayString);
            }
        })
    );
});