'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.MultiTreeSelectContent = exports.SingleTreeSelectContent = exports.TreeSelectContent = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var React = _interopRequireWildcard(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactList = require('react-list');

var _reactList2 = _interopRequireDefault(_reactList);

var _MultiSelect = require('../MultiSelect/MultiSelect');

var _KeyBoardNav = require('../Select/KeyBoardNav');

var _KeyBoardNav2 = _interopRequireDefault(_KeyBoardNav);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Link = require('../Link');

var _Link2 = _interopRequireDefault(_Link);

var _InputIcon = require('../InputIcon');

var _InputIcon2 = _interopRequireDefault(_InputIcon);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var TREE_PROPS = _extends({}, _MultiSelect.PROPERTY_TYPES, {
    hashLength: _propTypes2.default.number.isRequired,
    renderHeader: _propTypes2.default.func,
    footer: _propTypes2.default.node,
    multiple: _propTypes2.default.bool,
    highlightBroken: _propTypes2.default.bool
});

var TreeSelectContent = exports.TreeSelectContent = function (_React$Component) {
    _inherits(TreeSelectContent, _React$Component);

    function TreeSelectContent() {
        var _temp, _this, _ret;

        _classCallCheck(this, TreeSelectContent);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, _React$Component.call.apply(_React$Component, [this].concat(args))), _this), _this.state = {
            search: ''
        }, _this.optionsIn = [], _this.onChange = function (newValue) {
            _this.props.onChange(newValue);
        }, _this._applySearch = function (search) {
            _this.setState({ search: search });
        }, _this.renderOptions = function () {
            return React.createElement(
                'div',
                { className: 'select__popup' },
                React.createElement(
                    'div',
                    { className: 'select__search-container' },
                    React.createElement(_InputIcon2.default, {
                        inputRef: _this.handleInputRef,
                        value: _this.state.search,
                        ref: 'searchInput',
                        fluid: true,
                        placeholder: 'Search...',
                        size: 'sm',
                        onChange: _this._applySearch,
                        className: 'select__search',
                        iconClassName: 'im icon-search',
                        testId: 'tree_select_search'
                    })
                ),
                React.createElement(
                    'div',
                    { className: 'select__popup-header' },
                    _this.props.renderHeader ? _this.props.renderHeader(_this) : React.createElement(
                        'div',
                        null,
                        React.createElement(
                            'div',
                            { className: 'float-left' },
                            React.createElement(
                                _Link2.default,
                                {
                                    testId: 'tree_select_expand_all',
                                    className: 'tree-select__clear-btn',
                                    onClick: _this.expandCollapse(false)
                                },
                                'Expand all'
                            ),
                            React.createElement(
                                _Link2.default,
                                {
                                    testId: 'tree_select_collapse_all',
                                    className: 'tree-select__clear-btn',
                                    onClick: _this.expandCollapse(true)
                                },
                                'Collapse all'
                            )
                        ),
                        _this.props.multiple && React.createElement(
                            'div',
                            { className: 'float-right' },
                            React.createElement(
                                _Link2.default,
                                {
                                    testId: 'tree_select_clear_selected',
                                    className: 'tree-select__clear-btn',
                                    onClick: _this.clearSelected
                                },
                                'Clear selected'
                            )
                        )
                    )
                ),
                React.createElement(
                    'div',
                    { className: 'select__options', style: { clear: 'both', margin: '20px 0 0 0' } },
                    React.createElement(List, {
                        options: _this.options,
                        value: _this.props.value,
                        search: _this.state.search.toLowerCase(),
                        onChange: _this.onChange,
                        tree: _this.tree,
                        toggleExpanded: _this.toggleExpanded,
                        multiple: _this.props.multiple,
                        highlightBroken: _this.props.highlightBroken
                    })
                ),
                _this.props.footer ? React.createElement(
                    'div',
                    { className: 'select__popup-footer' },
                    _this.props.footer
                ) : null
            );
        }, _this.handleInputRef = function (input) {
            setTimeout(function () {
                if (input) {
                    input.focus();
                    _this.setState({
                        search: ''
                    });
                }
            }, 50);
        }, _this.clearSelected = function () {
            _this.props.onChange([]);
        }, _this.expandCollapse = function (collapsed) {
            return function (e) {
                e.preventDefault();
                _this.props.options.forEach(function (opt) {
                    opt.collapsed = collapsed;
                });
                _this.forceUpdate();
            };
        }, _this.toggleExpanded = function (option) {
            var opt = _this.props.options.find(function (op) {
                return op.id === option.id;
            });
            opt.collapsed = !opt.collapsed;
        }, _temp), _possibleConstructorReturn(_this, _ret);
    }

    TreeSelectContent.prototype.render = function render() {
        var _this2 = this;

        // create a local copy of options - to prevent props modification
        this.optionsIn = [].concat(_toConsumableArray(this.props.options.reduce(function (m, o) {
            return m.set(o.id, Object.assign(m.get(o.id) || {}, o));
        }, new Map()).values()));

        this.optionsIn.forEach(function (item) {
            item.children = null;
            // allow to use Tree select as simple select
            item.treeNodeHash = item.treeNodeHash || item.id;
            item.searchString = item.displayString.toLowerCase();
        });

        var treeNode = this.optionsIn.reduce(function (map, item) {
            var parentTreeHash = item.treeNodeHash.substring(0, item.treeNodeHash.length - _this2.props.hashLength);
            var parent = _this2.optionsIn.find(function (node) {
                return node.treeNodeHash === parentTreeHash;
            });
            if (parent) {
                parent.children = parent.children || [];
                parent.children.push(item);
                item.parent = parent;
            } else {
                map[item.treeNodeHash] = item;
            }
            return map;
        }, {});

        if (treeNode) {
            this.tree = {
                children: []
            };
            Object.keys(treeNode).forEach(function (nodeKey) {
                _this2.tree.children.push(treeNode[nodeKey]);
            });
        }

        this.options = this.buildOptionsFromTree(this.tree);
        return this.renderOptions();
    };

    TreeSelectContent.prototype.buildOptionsFromTree = function buildOptionsFromTree(tree) {
        var _this3 = this;

        var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

        if (!tree) {
            return [];
        }

        tree.children.sort(this.props.sort);
        tree.children.forEach(function (key) {
            options.push(key);
            if (key.children) {
                _this3.buildOptionsFromTree(key, options);
            }
        });
        return options;
    };

    return TreeSelectContent;
}(React.Component);

TreeSelectContent.propTypes = TREE_PROPS;
TreeSelectContent.defaultProps = {
    hashLength: 6,
    multiple: true,
    highlightBroken: true,
    sort: function sort(ak, bk) {
        return ak.displayString.localeCompare(bk.displayString);
    }
};

var List = function (_React$Component2) {
    _inherits(List, _React$Component2);

    function List() {
        var _temp2, _this4, _ret2;

        _classCallCheck(this, List);

        for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
            args[_key2] = arguments[_key2];
        }

        return _ret2 = (_temp2 = (_this4 = _possibleConstructorReturn(this, _React$Component2.call.apply(_React$Component2, [this].concat(args))), _this4), _this4.isSelected = function (item) {
            if (!_this4.props.multiple) {
                return _this4.props.value === item.id;
            }

            if (item.leaf) {
                return _this4.props.value.indexOf(item.id) > -1 ? List.selected.ALL : List.selected.NONE;
            } else if (item.children && item.children.reduce(function (pv, it) {
                if (pv) {
                    return _this4.isSelected(it) === List.selected.ALL;
                }
                return pv;
            }, true)) {
                return List.selected.ALL;
            }

            if (_this4.findSelectedChild(item)) {
                return List.selected.SOME;
            }

            return List.selected.NONE;
        }, _this4.findSelectedChild = function (item) {
            return item.children && item.children.find(function (child) {
                return _this4.isSelected(child) !== List.selected.NONE;
            });
        }, _this4.enable = function (option) {
            return _this4.select(option)(true);
        }, _this4.disable = function (option) {
            return _this4.select(option)(false);
        }, _this4.select = function (option) {
            return function (value) {
                return function () {
                    if (_this4.props.multiple) {
                        _this4.selectMultiple(option, value);
                    } else {
                        _this4.selectSingle(option, value);
                    }
                };
            };
        }, _this4.selectSingle = function (option, value) {
            _this4.props.onChange(option.id);
        }, _this4.selectMultiple = function (option, value) {
            var newValue = void 0;

            if (_this4.isSelected(option)) {
                if (value === true) {
                    return;
                }

                var leafs = _this4.getLeafs(option);
                newValue = _this4.props.value.filter(function (id) {
                    return !leafs.find(function (leaf) {
                        return leaf === id;
                    });
                });
            } else {
                if (value === false) {
                    return;
                }

                var _leafs = _this4.getLeafs(option);
                var newValueSet = new Set(_this4.props.value);
                _leafs.forEach(function (leaf) {
                    return newValueSet.add(leaf);
                });

                newValue = [].concat(_toConsumableArray(newValueSet));
            }

            _this4.props.onChange(newValue);
        }, _this4.getLeafs = function (option) {
            var result = [];
            var stack = [option];

            while (stack.length !== 0) {
                var current = stack.pop();
                current.children && current.children.forEach(function (child) {
                    return stack.push(child);
                });
                if (current.leaf) {
                    result.push(current.id);
                }
            }

            return result;
        }, _this4.calcDepth = function (option) {
            var p = option.parent;
            var count = 1;
            // placeholders don't have ID
            while (p && p.id) {
                p = p.parent;
                count++;
            }
            return count;
        }, _this4.renderItem = function (index, key) {
            var option = _this4.options[index];
            if (!_this4.isVisible(option)) {
                return null;
            }

            var selected = _this4.isSelected(option);
            var isBroken = _this4.props.highlightBroken && !option.leaf && (!option.children || option.children.length === 0);

            var className = (0, _classnames2.default)('check-box-list__item tree-select', {
                'single-tree-select--selected': !_this4.props.multiple && selected,
                'tree-select--inactive': !option.active
            });

            return React.createElement(
                'div',
                {
                    className: className,
                    key: option.id,
                    style: {
                        paddingLeft: (_this4.calcDepth(option) * 6 - 3) * 4 + (option.children ? 0 : 16) + 'px'
                    }
                },
                option.children ? React.createElement('span', {
                    className: ['expand im icon-arrow-down', _this4.isCollapsed(option) ? ' collapsed' : ''].join(' '),
                    onClick: _this4.toggleExpanded(option)
                }) : null,
                React.createElement(
                    'span',
                    {
                        onClick: _this4.select(option)(),
                        'data-test-id': option.displayString + '_select_option',
                        'data-test-checked': selected === true || option.leaf && selected === List.selected.ALL
                    },
                    _this4.props.multiple && React.createElement(
                        'span',
                        { className: 'check-box-list__check-box' },
                        selected === List.selected.ALL ? React.createElement(
                            'div',
                            { className: 'checkbox checked' },
                            React.createElement('i', { className: 'im icon-ok' })
                        ) : null,
                        selected === List.selected.NONE ? React.createElement('div', { className: 'checkbox' }) : null,
                        selected === List.selected.SOME ? React.createElement(
                            'div',
                            { className: 'checkbox checked' },
                            React.createElement('i', { className: 'im ion-minus' })
                        ) : null
                    ),
                    React.createElement(
                        'span',
                        {
                            className: ['check-box-list__label', 'tree-select__label', isBroken ? 'check-box-list__broken' : '', option.className ? option.className : ''].join(' '),
                            key: key
                        },
                        option.displayString
                    )
                )
            );
        }, _this4.isCollapsed = function (option) {
            return option.collapsed;
        }, _this4.isParentCollapsed = function (option) {
            var p = option.parent;
            while (p) {
                if (_this4.isCollapsed(p)) {
                    return true;
                }
                p = p.parent;
            }
        }, _this4.isFound = function (option) {
            var match = option.searchString.indexOf(_this4.props.search) !== -1;
            if (match) {
                return true;
            }
            if (option.children) {
                return option.children.reduce(function (prev, child) {
                    if (prev) {
                        return prev;
                    }
                    return _this4.isFound(child);
                }, false);
            }

            var p = option.parent;
            while (p && p.displayString) {
                if (p.searchString.indexOf(_this4.props.search) !== -1) {
                    return true;
                }
                p = p.parent;
            }

            return match;
        }, _this4.isVisible = function (option) {
            if (_this4.props.search !== '') {
                if (_this4.isFound(option)) {
                    return !_this4.isParentCollapsed(option);
                }

                if (option.children) {
                    return option.children.reduce(function (prev, child) {
                        if (prev) {
                            return prev;
                        }
                        return _this4.isFound(child);
                    }, false);
                }

                return false;
            }
            return !_this4.isParentCollapsed(option);
        }, _this4.toggleExpanded = function (option) {
            return function () {
                _this4.props.toggleExpanded(option);
                option.collapsed = !option.collapsed;

                _this4.setState({
                    render: Date.now()
                });
            };
        }, _this4.renderOptions = function (items, ref) {
            return React.createElement(
                'div',
                { ref: ref },
                items
            );
        }, _this4.renderTree = function (tree) {
            return tree.leaf ? React.createElement(
                'div',
                null,
                tree.displayString
            ) : React.createElement(
                'details',
                { open: true },
                React.createElement(
                    'summary',
                    null,
                    tree.displayString
                ),
                React.createElement(
                    'div',
                    null,
                    tree.children ? tree.children.map(function (chilld) {
                        return _this4.renderTree(chilld);
                    }) : null
                )
            );
        }, _temp2), _possibleConstructorReturn(_this4, _ret2);
    }

    List.prototype.render = function render() {
        return React.createElement(_reactList2.default, {
            itemRenderer: this.renderItem,
            itemsRenderer: this.renderOptions,
            length: this.options.length,
            type: 'uniform'
        });
    };

    _createClass(List, [{
        key: 'options',
        get: function get() {
            var _this5 = this;

            return this.props.options.filter(function (o) {
                return _this5.isVisible(o);
            });
        }
    }, {
        key: 'selected',
        get: function get() {
            var _this6 = this;

            if (this.props.multiple) {
                return this.props.value.filter(function (id) {
                    var item = _this6.props.options.find(function (o) {
                        return o.id === id;
                    });
                    if (!item) {
                        console.warn('Impossible value detected');
                    }
                    return _this6.isSelected(item) === List.selected.ALL;
                });
            } else {
                if (!this.props.value) {
                    return null;
                }

                var item = this.props.options.find(function (o) {
                    return o.id === _this6.props.value;
                });
                if (!item) {
                    console.warn('Impossible value detected');
                }
                return this.props.value;
            }
        }
    }]);

    return List;
}(React.Component);

List.propTypes = {
    highlightBroken: _propTypes2.default.bool
};
List.selected = {
    NONE: 0,
    ALL: 1,
    SOME: 2
};
List.defaultProps = {
    value: []
};

var Single = function (_React$Component3) {
    _inherits(Single, _React$Component3);

    function Single() {
        _classCallCheck(this, Single);

        return _possibleConstructorReturn(this, _React$Component3.apply(this, arguments));
    }

    Single.prototype.render = function render() {
        return React.createElement(TreeSelectContent, _extends({}, this.props, { multiple: false }));
    };

    return Single;
}(React.Component);

var Multi = function (_React$Component4) {
    _inherits(Multi, _React$Component4);

    function Multi() {
        _classCallCheck(this, Multi);

        return _possibleConstructorReturn(this, _React$Component4.apply(this, arguments));
    }

    Multi.prototype.render = function render() {
        return React.createElement(TreeSelectContent, this.props);
    };

    return Multi;
}(React.Component);

var SingleTreeSelectContent = exports.SingleTreeSelectContent = (0, _KeyBoardNav2.default)(false)(Single);
var MultiTreeSelectContent = exports.MultiTreeSelectContent = (0, _KeyBoardNav2.default)(true)(Multi);