'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.enhanceWithKeyDown = enhanceWithKeyDown;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _events = require('../constant/events');

var _utils = require('../../util/utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function enhanceWithKeyDown(ParentClass) {
    var Enhance = function (_ParentClass) {
        _inherits(Enhance, _ParentClass);

        _createClass(Enhance, null, [{
            key: 'displayName',
            get: function get() {
                return ParentClass.displayName || ParentClass.name;
            }
        }]);

        function Enhance() {
            _classCallCheck(this, Enhance);

            var _this = _possibleConstructorReturn(this, _ParentClass.apply(this, arguments));

            _this.handleKeyDown = _this.handleKeyDown.bind(_this);
            return _this;
        }

        Enhance.prototype.componentDidMount = function componentDidMount() {
            if (_ParentClass.prototype.componentDidMount) {
                var _ParentClass$prototyp;

                (_ParentClass$prototyp = _ParentClass.prototype.componentDidMount).call.apply(_ParentClass$prototyp, [this].concat(Array.prototype.slice.call(arguments)));
            }
            document.addEventListener(_events.KEY_DOWN, this.handleKeyDown);
        };

        Enhance.prototype.componentWillUnmount = function componentWillUnmount() {
            if (_ParentClass.prototype.componentWillUnmount) {
                var _ParentClass$prototyp2;

                (_ParentClass$prototyp2 = _ParentClass.prototype.componentWillUnmount).call.apply(_ParentClass$prototyp2, [this].concat(Array.prototype.slice.call(arguments)));
            }
            document.removeEventListener(_events.KEY_DOWN, this.handleKeyDown);
        };

        Enhance.prototype.handleKeyDown = function handleKeyDown(_ref) {
            var keyCode = _ref.keyCode;

            if ((0, _utils.isFunction)(_ParentClass.prototype.handleKeyDown)) {
                _ParentClass.prototype.handleKeyDown.call(this, keyCode);
            }
        };

        return Enhance;
    }(ParentClass);

    Enhance.propTypes = ParentClass.propTypes;
    Enhance.defaultProps = ParentClass.defaultProps;
    Enhance.childContextTypes = ParentClass.childContextTypes;
    Enhance.contextTypes = ParentClass.contextTypes;
    return Enhance;
}