'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.compare = exports.contains = exports.isInArray = exports.isDefined = exports.isFunction = exports.findIdentifiables = undefined;

var _isUndefined = require('lodash/isUndefined');

var _isUndefined2 = _interopRequireDefault(_isUndefined);

var _find = require('lodash/find');

var _find2 = _interopRequireDefault(_find);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function isFunction(possibleFunction) {
    return typeof possibleFunction === 'function';
}

function isDefined(value) {
    return !(0, _isUndefined2.default)(value);
}

function isInArray(value, arr) {
    return arr.indexOf(value) !== -1;
}

function contains(value, value2) {
    return value.toUpperCase().indexOf(value2.toUpperCase()) !== -1;
}

function findIdentifiables(list, toFindIds) {
    var result = list.filter(function (item) {
        return !(0, _isUndefined2.default)((0, _find2.default)(toFindIds, function (toFindId) {
            return toFindId === item.id;
        }));
    });
    return isDefined(result) ? result : [];
}

function compare(left, right) {
    if (left === right) {
        return 0;
    } else if (left > right) {
        return 1;
    } else {
        return -1;
    }
}

exports.findIdentifiables = findIdentifiables;
exports.isFunction = isFunction;
exports.isDefined = isDefined;
exports.isInArray = isInArray;
exports.contains = contains;
exports.compare = compare;